`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    21:09:47 03/12/2008 
// Design Name: 
// Module Name:    adder 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////

/*
This module calculates semi-Euclidean "distance" between two Cartesian coordinates. In this lovely
fantasy world, the "distance" between two points is defined as:

%To keep implementation in hardware
%simple, this clustering algorithm operates on quasi-Euclidean distance,
%defined between two points P0(x0,y0) and P1(y1,y1) as
%           D = abs(x1-x0) + abs(y1-y0)

from the Matlab simulation file that was originally used to model this (blob_cluster.m)

As of 11:33PM, Mar 12/08, this module has been tested with a few values covering some of
the major test cases. It requires further testing!
*/

module distance(	point1m, point1n,
						point2m, point2n, 
						distance
				);
/* 
The points are enumerated matrix style, from the top-left corner of the picture. Coordinates are
in the row-column syntax, enumerated 'm' and 'n,' respectively.

INPUTS AND OUTPUTS ARE ASSUMED TO BE UNSIGNED!! VERY IMPORTANT!
*/

input  [9:0] 	point1m, point2m;
input  [8:0] 	point1n, point2n;
output [10:0] 	distance;

wire   [9:0] 	mdist;
wire   [8:0] 	ndist;

wire   [9:0] 	amdist;
wire   [8:0] 	andist;

//Calculate m (x) distance
assign mdist = point2m - point1m;

//Calculate n (y) distance
assign ndist = point2n - point1n;

absolute10 md (
    .din	( mdist ), 
    .dout( amdist )
    );
absolute9 nd (
    .din	( ndist ), 
    .dout( andist )
    );


//sum it up
assign distance = amdist + andist;

endmodule
