`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    21:09:47 03/12/2008 
// Design Name: 
// Module Name:    adder 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////

/*
This module calculates the distance components between two points, 2 and 1. The
relevant matlab code is:

                    xdist = blist_cluster( bi+i, 1 ) - blist_cluster( bi, 1 );
                    ydist = blist_cluster( bi+i, 2 ) - blist_cluster( bi, 2 );
						  
THE OUTPUTS ARE SIGNED! 

Modestly tested as of 11:49PM, March 12/08. Works! So far...

*/

module distance_comp(	point1m, point1n,
								point2m, point2n, 
								distancem, distancen
				);
/* 
The points are enumerated matrix style, from the top-left corner of the picture. Coordinates are
in the row-column syntax, enumerated 'm' and 'n,' respectively.

INPUTS ARE ASSUMED TO BE UNSIGNED!! VERY IMPORTANT!
*/

input  [9:0] 	point1m, point2m;
input  [8:0] 	point1n, point2n;
output [10:0] 	distancem;
output [9:0] 	distancen;

wire signed [10:0] 	distancem;
wire signed [9:0] 	distancen;

//Calculate m (x) distance
assign distancem = point2m - point1m;

//Calculate n (y) distance
assign distancen = point2n - point1n;

endmodule
