module vidcap(
	BRAM_Rst_B,
	BRAM_Clk_B,
	BRAM_EN_B,
	BRAM_WEN_B,
	BRAM_Addr_B,
	BRAM_Din_B,
	BRAM_Dout_B,

	YCrCb_in,
	LLC_CLOCK,
	RESET_VDEC1_Z,
	VDEC1_OE_Z,
	VDEC1_PWRDN_Z
);

input			BRAM_Rst_B;
input			BRAM_Clk_B;
input			BRAM_EN_B;
input	[0:7]	BRAM_WEN_B;
input	[0:31]	BRAM_Addr_B;
output	[0:63]	BRAM_Din_B;
input	[0:63]	BRAM_Dout_B;

input	[9:2]	YCrCb_in;
input			LLC_CLOCK;
output			RESET_VDEC1_Z;
output			VDEC1_OE_Z;
output			VDEC1_PWRDN_Z;


wire			wVidMemClk;
wire	[0:63]	wVidMemData;
wire	[0:11]	wVidMemAddr;
wire			wVidMemWE;


//Reads data from video stream and writes it to VidMem
vid2vidmem	VideoDecoder(
	.iYCrCb_in(YCrCb_in),
	.iLLC_CLOCK(LLC_CLOCK),
	.iReset(BRAM_Rst_B),
	.oRESET_VDEC1_Z(oRESET_VDEC1_Z),
	.oVDEC1_OE_Z(oVDEC1_OE_Z),
	.oVDEC1_PWRDN_Z(oVDEC1_PWRDN_Z),

	.oVidMemClk(wVidMemClk),
	.oVidMemData(wVidMemData),
	.oVidMemAddr(wVidMemAddr),
	.oVidMemWE(wVidMemWE),

	.iPDClk(),
	.iPDAddr(),
	.oPDData(),
	.oHSync(),
	.oVSync()
);

//Memory to store a few lines for display
blk_mem_gen_v2_3 VidMem (
	.clka(wVidMemClk),
	.dina(wVidMemData),
	.addra(wVidMemAddr),
	.ena(1'b1),
	.wea(wVidMemWE),

	.clkb(BRAM_Clk_B),
	.addrb(BRAM_Addr_B[17:28]),
	.enb(1'b1),
	.ssrb(BRAM_Rst_B),
	.doutb(BRAM_Din_B)
);

endmodule
