#include "collidable.h"
#include <stdio.h>

int checkCrossing(struct wall w, struct point2 pi, struct point2 pf)
{
   struct vector2 vi, vf;

   vi = p_minus_p(pi, w.pOrigin);
   vf = p_minus_p(pf, w.pOrigin);
   //printf("pi(%f, %f), pf(%f, %f) \n", pi.x, pi.y, pf.x, pf.y);
   //printf("vi(%f, %f), vf(%f, %f) \n", vi.x, vi.y, vf.x, vf.y);
   //printf("vi*norm(%f), vf*norm(%f) \n", v_dot_v(vi, w.uNormal), v_dot_v(vf, w.uNormal));
   /*if ((v_dot_v(vi, w.uNormal) > 0) && (v_dot_v(vf, w.uNormal) < 0))
      printf("one true\n");
   if ((v_dot_v(vi, w.uNormal) > 0) && (v_dot_v(vf, w.uNormal) < 0))
      printf("two true\n");*/

   if ((v_dot_v(vi, w.uNormal) == 0) ||
       ((v_dot_v(vi, w.uNormal) > 0) && (v_dot_v(vf, w.uNormal) < 0)) ||
       ((v_dot_v(vi, w.uNormal) < 0) && (v_dot_v(vf, w.uNormal) > 0)))
      return 1;
   else
      return 0;
   
}

int checkParallel(struct vector2 v1, struct vector2 v2)
{
   if ((v1.x * v2.y - v1.y *v2.x) == 0)
      return 1;
   else
      return 0;
}

struct point2 findCollisionPoint(struct wall w, struct point2 pi, struct point2 pf)
{
   struct point2 temp;
   struct vector2 v;

   v = p_minus_p(pf, pi); 

   temp.x = (w.uDir.x*v.x*w.pOrigin.y - w.pOrigin.x*w.uDir.y*v.x + w.uDir.x*v.y*pi.x - w.uDir.x*v.x*pi.y)/(w.uDir.x*v.y - w.uDir.y*v.x);
   temp.y = (w.pOrigin.y*w.uDir.x*v.y - w.uDir.y*v.y*w.pOrigin.x + w.uDir.y*v.y*pi.x - w.uDir.y*v.x*pi.y)/(w.uDir.x*v.y - w.uDir.y*v.x);

   return temp;
}

struct vector2 reflectVector(struct wall w, struct vector2 v)
{
   return v_add_v(v, scale_v(w.uNormal, -2*v_dot_v(w.uNormal, v)));
}

