#################################################################
# Makefile generated by Xilinx Platform Studio 
# Project:C:\ece532\ssbase1\system.xmp
#################################################################

XILINX_EDK_DIR = D:/EDK

SYSTEM = system

MHSFILE = system.mhs

MSSFILE = system.mss

FPGA_ARCH = virtex2p

DEVICE = xc2vp30ff896-7

LANGUAGE = vhdl

SEARCHPATHOPT =  -lp C:/ece532/lib/

SUBMODULE_OPT = 

PLATGEN_OPTIONS = -p $(DEVICE) -lang $(LANGUAGE) $(SEARCHPATHOPT) $(SUBMODULE_OPT)

LIBGEN_OPTIONS = -mhs $(MHSFILE) -p $(DEVICE) $(SEARCHPATHOPT)

VPGEN_OPTIONS = -p $(DEVICE) $(SEARCHPATHOPT)

PPC0_DEFAULT_OUTPUT_DIR = ppc0_default
PPC0_DEFAULT_OUTPUT = $(PPC0_DEFAULT_OUTPUT_DIR)/executable.elf

GAME_OUTPUT_DIR = game
GAME_OUTPUT = $(GAME_OUTPUT_DIR)/executable.elf

MICROBLAZE_BOOTLOOP = $(XILINX_EDK_DIR)/sw/lib/microblaze/mb_bootloop.elf
PPC405_BOOTLOOP = $(XILINX_EDK_DIR)/sw/lib/ppc405/ppc_bootloop.elf
PPC440_BOOTLOOP = $(XILINX_EDK_DIR)/sw/lib/ppc440/ppc440_bootloop.elf
BOOTLOOP_DIR = bootloops

PPC405_0_BOOTLOOP = $(BOOTLOOP_DIR)/ppc405_0.elf

PPC405_1_BOOTLOOP = $(BOOTLOOP_DIR)/ppc405_1.elf

BRAMINIT_ELF_FILES =  $(GAME_OUTPUT) 
BRAMINIT_ELF_FILE_ARGS =   -pe ppc405_0 $(GAME_OUTPUT) 

ALL_USER_ELF_FILES = $(PPC0_DEFAULT_OUTPUT) $(GAME_OUTPUT) 

SIM_CMD = vsim

BEHAVIORAL_SIM_SCRIPT = simulation/behavioral/$(SYSTEM).do

STRUCTURAL_SIM_SCRIPT = simulation/structural/$(SYSTEM).do

TIMING_SIM_SCRIPT = simulation/timing/$(SYSTEM).do

DEFAULT_SIM_SCRIPT = $(BEHAVIORAL_SIM_SCRIPT)

MIX_LANG_SIM_OPT = -mixed yes

SIMGEN_OPTIONS = -p $(DEVICE) -lang $(LANGUAGE) $(SEARCHPATHOPT) $(BRAMINIT_ELF_FILE_ARGS) $(MIX_LANG_SIM_OPT)  -s mti


LIBRARIES =  \
       ppc405_0/lib/libxil.a  \
       ppc405_1/lib/libxil.a 
VPEXEC = virtualplatform/vpexec.exe

LIBSCLEAN_TARGETS = ppc405_0_libsclean ppc405_1_libsclean 

PROGRAMCLEAN_TARGETS = ppc0_default_programclean game_programclean 

CORE_STATE_DEVELOPMENT_FILES = 

WRAPPER_NGC_FILES = implementation/ppc405_0_wrapper.ngc \
implementation/ppc405_1_wrapper.ngc \
implementation/jtagppc_0_wrapper.ngc \
implementation/reset_block_wrapper.ngc \
implementation/plb_wrapper.ngc \
implementation/opb_wrapper.ngc \
implementation/plb2opb_wrapper.ngc \
implementation/rs232_uart_1_wrapper.ngc \
implementation/sysace_compactflash_wrapper.ngc \
implementation/pushbuttons_5bit_wrapper.ngc \
implementation/ddr_256mb_32mx64_rank1_row13_col10_cl2_5_wrapper.ngc \
implementation/audio_codec_wrapper.ngc \
implementation/plb_bram_if_cntlr_1_wrapper.ngc \
implementation/plb_bram_if_cntlr_1_bram_wrapper.ngc \
implementation/dcm_0_wrapper.ngc \
implementation/dcm_1_wrapper.ngc \
implementation/opb2dcr_bridge_0_wrapper.ngc \
implementation/vga_framebuffer_wrapper.ngc \
implementation/dcr_v29_0_wrapper.ngc

POSTSYN_NETLIST = implementation/$(SYSTEM).ngc

SYSTEM_BIT = implementation/$(SYSTEM).bit

DOWNLOAD_BIT = implementation/download.bit

SYSTEM_ACE = implementation/$(SYSTEM).ace

UCF_FILE = data/system.ucf

BMM_FILE = implementation/$(SYSTEM).bmm

BITGEN_UT_FILE = etc/bitgen.ut

XFLOW_OPT_FILE = etc/fast_runtime.opt
XFLOW_DEPENDENCY = __xps/xpsxflow.opt $(XFLOW_OPT_FILE)

XPLORER_DEPENDENCY = __xps/xplorer.opt
XPLORER_OPTIONS = -p $(DEVICE) -uc $(SYSTEM).ucf -bm $(SYSTEM).bmm -max_runs 7

FPGA_IMP_DEPENDENCY = $(BMM_FILE) $(POSTSYN_NETLIST) $(UCF_FILE) $(BITGEN_UT_FILE) $(XFLOW_DEPENDENCY)

#################################################################
# SOFTWARE APPLICATION PPC0_DEFAULT
#################################################################

PPC0_DEFAULT_SOURCES = ppc0_default/vgademo.c ppc0_default/sleep.c ppc0_default/vga.c 

PPC0_DEFAULT_HEADERS = ppc0_default/vgademo.h ppc0_default/sleep.h ppc0_default/vga.h 

PPC0_DEFAULT_CC = powerpc-eabi-gcc
PPC0_DEFAULT_CC_SIZE = powerpc-eabi-size
PPC0_DEFAULT_CC_OPT = -O2
PPC0_DEFAULT_CFLAGS = 
PPC0_DEFAULT_CC_SEARCH = # -B
PPC0_DEFAULT_LIBPATH = -L./ppc405_0/lib/ # -L
PPC0_DEFAULT_INCLUDES = -I./ppc405_0/include/  -Ippc0_default/ # -I
PPC0_DEFAULT_LFLAGS = # -l
PPC0_DEFAULT_LINKER_SCRIPT = 
PPC0_DEFAULT_LINKER_SCRIPT_FLAG = #-Wl,-T -Wl,$(PPC0_DEFAULT_LINKER_SCRIPT) 
PPC0_DEFAULT_CC_DEBUG_FLAG =  -g 
PPC0_DEFAULT_CC_PROFILE_FLAG = # -pg
PPC0_DEFAULT_CC_GLOBPTR_FLAG= # -msdata=eabi
PPC0_DEFAULT_CC_START_ADDR_FLAG=  # -Wl,-defsym -Wl,_START_ADDR=
PPC0_DEFAULT_CC_STACK_SIZE_FLAG=  # -Wl,-defsym -Wl,_STACK_SIZE=
PPC0_DEFAULT_CC_HEAP_SIZE_FLAG=  # -Wl,-defsym -Wl,_HEAP_SIZE=
PPC0_DEFAULT_OTHER_CC_FLAGS= $(PPC0_DEFAULT_CC_GLOBPTR_FLAG)  \
                  $(PPC0_DEFAULT_CC_START_ADDR_FLAG) $(PPC0_DEFAULT_CC_STACK_SIZE_FLAG) $(PPC0_DEFAULT_CC_HEAP_SIZE_FLAG)  \
                  $(PPC0_DEFAULT_LINKER_SCRIPT_FLAG) $(PPC0_DEFAULT_CC_DEBUG_FLAG) $(PPC0_DEFAULT_CC_PROFILE_FLAG) 

#################################################################
# SOFTWARE APPLICATION GAME
#################################################################

GAME_SOURCES = game/2D_types.c game/ball.c game/collidable.c game/draw.c game/main.c game/vga.c 

GAME_HEADERS = game/draw.h game/2D_types.h game/ball.h game/collidable.h game/vga.h game/main.h 

GAME_CC = powerpc-eabi-gcc
GAME_CC_SIZE = powerpc-eabi-size
GAME_CC_OPT = -O0
GAME_CFLAGS = 
GAME_CC_SEARCH = # -B
GAME_LIBPATH = -L./ppc405_0/lib/ # -L
GAME_INCLUDES = -I./ppc405_0/include/  -Igame/ # -I
GAME_LFLAGS = # -l
GAME_LINKER_SCRIPT = 
GAME_LINKER_SCRIPT_FLAG = #-Wl,-T -Wl,$(GAME_LINKER_SCRIPT) 
GAME_CC_DEBUG_FLAG =  -g 
GAME_CC_PROFILE_FLAG = # -pg
GAME_CC_GLOBPTR_FLAG= # -msdata=eabi
GAME_CC_START_ADDR_FLAG=  # -Wl,-defsym -Wl,_START_ADDR=
GAME_CC_STACK_SIZE_FLAG=  # -Wl,-defsym -Wl,_STACK_SIZE=
GAME_CC_HEAP_SIZE_FLAG=  # -Wl,-defsym -Wl,_HEAP_SIZE=
GAME_OTHER_CC_FLAGS= $(GAME_CC_GLOBPTR_FLAG)  \
                  $(GAME_CC_START_ADDR_FLAG) $(GAME_CC_STACK_SIZE_FLAG) $(GAME_CC_HEAP_SIZE_FLAG)  \
                  $(GAME_LINKER_SCRIPT_FLAG) $(GAME_CC_DEBUG_FLAG) $(GAME_CC_PROFILE_FLAG) 
