#include "2D_types.h"

struct point2 p_add_v(struct point2 p, struct vector2 v)
{
   struct point2 temp;

   temp.x = p.x + v.x;
   temp.y = p.y + v.y;

   return temp;
}

struct vector2 p_minus_p(struct point2 p1, struct point2 p2)
{
   struct vector2 temp;

   temp.x = p1.x - p2.x;
   temp.y = p1.y - p2.y;

   return temp;
}

struct vector2 v_add_v(struct vector2 v1, struct vector2 v2)
{
   struct vector2 temp;

   temp.x = v1.x + v2.x;
   temp.y = v1.y + v2.y;

   return temp;
}

struct vector2 scale_v(struct vector2 v, float s)
{
   struct vector2 temp;

   temp.x = v.x * s;
   temp.y = v.y * s;

   return temp;
}

float v_dot_v(struct vector2 v1, struct vector2 v2)
{
   return ((v1.x * v2.x) + (v1.y * v2.y));
}

float length_v(struct vector2 v)
{
   return sqrt(v.x*v.x + v.y*v.y);
}

struct vector2 unit_v(struct vector2 v)
{
   return scale_v(v, 1/length_v(v));
}

struct vector2 normal_v_right(struct vector2 v)
{
   struct vector2 temp;

   temp.x = -temp.y;
   temp.y = temp.x;

   return temp;
}

struct vector2 normal_v_left(struct vector2 v)
{
   struct vector2 temp;

   temp.x = temp.y;
   temp.y = -temp.x;

   return temp;
}

