`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    23:37:13 02/29/2008 
// Design Name: 
// Module Name:    twos_complement 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////

/* This module returns the absolute value of the input number. The input number is
assumed to be in 2's complement notation (ie. the MSB is the sign bit.) */

module absolute9(	din,	//data in
						dout	//data out
								
					 );
								
parameter NUM_BITS = 9;

	input  [NUM_BITS-1:0] din;
	output [NUM_BITS-1:0] dout;
	
	reg [NUM_BITS-1:0] dout;

	wire [NUM_BITS-1:0] flip;

	twos_comp_finder9 finder (
		 .op		( din ), 
		 .found	( flip )
		 );

	//if as == 0, return original. Else, return 2's complement.
	//assign dout = as ? din^flip : din;
	always@( din ) begin
		if( din[NUM_BITS-1] )
			dout = din^flip;
		else
			dout = din;
	end


endmodule
