`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    00:14:14 03/05/2008 
// Design Name: 
// Module Name:    islocal_min 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module islocal_min2(
							dM,			//input data array
							islocalmin	//output data array
							//go,			//edge triggered signal to do one cycle of computation
							//mclk,			//clk to compute on.
							//rst
						 );

	//size of incoming data
	parameter NUM_BITS = 8;
	//size of output
	parameter DSQ_BITS = 8;
	//size of memory array
	parameter WIDTH  	 = 7;
	parameter LENGTH   = 7;
	
	parameter signed MIN_DET  = -50;
	
	//input go, mclk, rst;	
	input signed [527:0] dM;
	//islocalmin output is 1 bit per pixel, for 24 pixels per frame.
	output [23:0] islocalmin;	

wire [8:0] dM_02_02_comp;
wire signed [10:0] dM_02_02_ctrpt = dM [109:99];
wire signed [10:0] dM_02_02_point0 = dM [10:0];
assign dM_02_02_comp[0] = (dM_02_02_point0 >= dM_02_02_ctrpt);
wire signed [10:0] dM_02_02_point1 = dM [21:11];
assign dM_02_02_comp[1] = (dM_02_02_point1 >= dM_02_02_ctrpt);
wire signed [10:0] dM_02_02_point2 = dM [32:22];
assign dM_02_02_comp[2] = (dM_02_02_point2 >= dM_02_02_ctrpt);
wire signed [10:0] dM_02_02_point3 = dM [98:88];
assign dM_02_02_comp[3] = (dM_02_02_point3 >= dM_02_02_ctrpt);
wire signed [10:0] dM_02_02_point4 = dM [120:110];
assign dM_02_02_comp[4] = (dM_02_02_point4 >= dM_02_02_ctrpt);
wire signed [10:0] dM_02_02_point5 = dM [186:176];
assign dM_02_02_comp[5] = (dM_02_02_point5 >= dM_02_02_ctrpt);
wire signed [10:0] dM_02_02_point6 = dM [197:187];
assign dM_02_02_comp[6] = (dM_02_02_point6 >= dM_02_02_ctrpt);
wire signed [10:0] dM_02_02_point7 = dM [208:198];
assign dM_02_02_comp[7] = (dM_02_02_point7 >= dM_02_02_ctrpt);
wire signed [10:0] dM_02_02_MINDET;
assign dM_02_02_MINDET = dM [109:99];
assign dM_02_02_comp[8] = (dM_02_02_MINDET < MIN_DET);
assign islocalmin[0] =	&dM_02_02_comp;


wire [8:0] dM_03_02_comp;
wire signed [10:0] dM_03_02_ctrpt = dM [197:187];
wire signed [10:0] dM_03_02_point0 = dM [98:88];
assign dM_03_02_comp[0] = (dM_03_02_point0 >= dM_03_02_ctrpt);
wire signed [10:0] dM_03_02_point1 = dM [109:99];
assign dM_03_02_comp[1] = (dM_03_02_point1 >= dM_03_02_ctrpt);
wire signed [10:0] dM_03_02_point2 = dM [120:110];
assign dM_03_02_comp[2] = (dM_03_02_point2 >= dM_03_02_ctrpt);
wire signed [10:0] dM_03_02_point3 = dM [186:176];
assign dM_03_02_comp[3] = (dM_03_02_point3 >= dM_03_02_ctrpt);
wire signed [10:0] dM_03_02_point4 = dM [208:198];
assign dM_03_02_comp[4] = (dM_03_02_point4 >= dM_03_02_ctrpt);
wire signed [10:0] dM_03_02_point5 = dM [274:264];
assign dM_03_02_comp[5] = (dM_03_02_point5 >= dM_03_02_ctrpt);
wire signed [10:0] dM_03_02_point6 = dM [285:275];
assign dM_03_02_comp[6] = (dM_03_02_point6 >= dM_03_02_ctrpt);
wire signed [10:0] dM_03_02_point7 = dM [296:286];
assign dM_03_02_comp[7] = (dM_03_02_point7 >= dM_03_02_ctrpt);
wire signed [10:0] dM_03_02_MINDET;
assign dM_03_02_MINDET = dM [197:187];
assign dM_03_02_comp[8] = (dM_03_02_MINDET < MIN_DET);
assign islocalmin[6] =	&dM_03_02_comp;


wire [8:0] dM_04_02_comp;
wire signed [10:0] dM_04_02_ctrpt = dM [285:275];
wire signed [10:0] dM_04_02_point0 = dM [186:176];
assign dM_04_02_comp[0] = (dM_04_02_point0 >= dM_04_02_ctrpt);
wire signed [10:0] dM_04_02_point1 = dM [197:187];
assign dM_04_02_comp[1] = (dM_04_02_point1 >= dM_04_02_ctrpt);
wire signed [10:0] dM_04_02_point2 = dM [208:198];
assign dM_04_02_comp[2] = (dM_04_02_point2 >= dM_04_02_ctrpt);
wire signed [10:0] dM_04_02_point3 = dM [274:264];
assign dM_04_02_comp[3] = (dM_04_02_point3 >= dM_04_02_ctrpt);
wire signed [10:0] dM_04_02_point4 = dM [296:286];
assign dM_04_02_comp[4] = (dM_04_02_point4 >= dM_04_02_ctrpt);
wire signed [10:0] dM_04_02_point5 = dM [362:352];
assign dM_04_02_comp[5] = (dM_04_02_point5 >= dM_04_02_ctrpt);
wire signed [10:0] dM_04_02_point6 = dM [373:363];
assign dM_04_02_comp[6] = (dM_04_02_point6 >= dM_04_02_ctrpt);
wire signed [10:0] dM_04_02_point7 = dM [384:374];
assign dM_04_02_comp[7] = (dM_04_02_point7 >= dM_04_02_ctrpt);
wire signed [10:0] dM_04_02_MINDET;
assign dM_04_02_MINDET = dM [285:275];
assign dM_04_02_comp[8] = (dM_04_02_MINDET < MIN_DET);
assign islocalmin[12] =	&dM_04_02_comp;


wire [8:0] dM_05_02_comp;
wire signed [10:0] dM_05_02_ctrpt = dM [373:363];
wire signed [10:0] dM_05_02_point0 = dM [274:264];
assign dM_05_02_comp[0] = (dM_05_02_point0 >= dM_05_02_ctrpt);
wire signed [10:0] dM_05_02_point1 = dM [285:275];
assign dM_05_02_comp[1] = (dM_05_02_point1 >= dM_05_02_ctrpt);
wire signed [10:0] dM_05_02_point2 = dM [296:286];
assign dM_05_02_comp[2] = (dM_05_02_point2 >= dM_05_02_ctrpt);
wire signed [10:0] dM_05_02_point3 = dM [362:352];
assign dM_05_02_comp[3] = (dM_05_02_point3 >= dM_05_02_ctrpt);
wire signed [10:0] dM_05_02_point4 = dM [384:374];
assign dM_05_02_comp[4] = (dM_05_02_point4 >= dM_05_02_ctrpt);
wire signed [10:0] dM_05_02_point5 = dM [450:440];
assign dM_05_02_comp[5] = (dM_05_02_point5 >= dM_05_02_ctrpt);
wire signed [10:0] dM_05_02_point6 = dM [461:451];
assign dM_05_02_comp[6] = (dM_05_02_point6 >= dM_05_02_ctrpt);
wire signed [10:0] dM_05_02_point7 = dM [472:462];
assign dM_05_02_comp[7] = (dM_05_02_point7 >= dM_05_02_ctrpt);
wire signed [10:0] dM_05_02_MINDET;
assign dM_05_02_MINDET = dM [373:363];
assign dM_05_02_comp[8] = (dM_05_02_MINDET < MIN_DET);
assign islocalmin[18] =	&dM_05_02_comp;


wire [8:0] dM_02_03_comp;
wire signed [10:0] dM_02_03_ctrpt = dM [120:110];
wire signed [10:0] dM_02_03_point0 = dM [21:11];
assign dM_02_03_comp[0] = (dM_02_03_point0 >= dM_02_03_ctrpt);
wire signed [10:0] dM_02_03_point1 = dM [32:22];
assign dM_02_03_comp[1] = (dM_02_03_point1 >= dM_02_03_ctrpt);
wire signed [10:0] dM_02_03_point2 = dM [43:33];
assign dM_02_03_comp[2] = (dM_02_03_point2 >= dM_02_03_ctrpt);
wire signed [10:0] dM_02_03_point3 = dM [109:99];
assign dM_02_03_comp[3] = (dM_02_03_point3 >= dM_02_03_ctrpt);
wire signed [10:0] dM_02_03_point4 = dM [131:121];
assign dM_02_03_comp[4] = (dM_02_03_point4 >= dM_02_03_ctrpt);
wire signed [10:0] dM_02_03_point5 = dM [197:187];
assign dM_02_03_comp[5] = (dM_02_03_point5 >= dM_02_03_ctrpt);
wire signed [10:0] dM_02_03_point6 = dM [208:198];
assign dM_02_03_comp[6] = (dM_02_03_point6 >= dM_02_03_ctrpt);
wire signed [10:0] dM_02_03_point7 = dM [219:209];
assign dM_02_03_comp[7] = (dM_02_03_point7 >= dM_02_03_ctrpt);
wire signed [10:0] dM_02_03_MINDET;
assign dM_02_03_MINDET = dM [120:110];
assign dM_02_03_comp[8] = (dM_02_03_MINDET < MIN_DET);
assign islocalmin[1] =	&dM_02_03_comp;


wire [8:0] dM_03_03_comp;
wire signed [10:0] dM_03_03_ctrpt = dM [208:198];
wire signed [10:0] dM_03_03_point0 = dM [109:99];
assign dM_03_03_comp[0] = (dM_03_03_point0 >= dM_03_03_ctrpt);
wire signed [10:0] dM_03_03_point1 = dM [120:110];
assign dM_03_03_comp[1] = (dM_03_03_point1 >= dM_03_03_ctrpt);
wire signed [10:0] dM_03_03_point2 = dM [131:121];
assign dM_03_03_comp[2] = (dM_03_03_point2 >= dM_03_03_ctrpt);
wire signed [10:0] dM_03_03_point3 = dM [197:187];
assign dM_03_03_comp[3] = (dM_03_03_point3 >= dM_03_03_ctrpt);
wire signed [10:0] dM_03_03_point4 = dM [219:209];
assign dM_03_03_comp[4] = (dM_03_03_point4 >= dM_03_03_ctrpt);
wire signed [10:0] dM_03_03_point5 = dM [285:275];
assign dM_03_03_comp[5] = (dM_03_03_point5 >= dM_03_03_ctrpt);
wire signed [10:0] dM_03_03_point6 = dM [296:286];
assign dM_03_03_comp[6] = (dM_03_03_point6 >= dM_03_03_ctrpt);
wire signed [10:0] dM_03_03_point7 = dM [307:297];
assign dM_03_03_comp[7] = (dM_03_03_point7 >= dM_03_03_ctrpt);
wire signed [10:0] dM_03_03_MINDET;
assign dM_03_03_MINDET = dM [208:198];
assign dM_03_03_comp[8] = (dM_03_03_MINDET < MIN_DET);
assign islocalmin[7] =	&dM_03_03_comp;


wire [8:0] dM_04_03_comp;
wire signed [10:0] dM_04_03_ctrpt = dM [296:286];
wire signed [10:0] dM_04_03_point0 = dM [197:187];
assign dM_04_03_comp[0] = (dM_04_03_point0 >= dM_04_03_ctrpt);
wire signed [10:0] dM_04_03_point1 = dM [208:198];
assign dM_04_03_comp[1] = (dM_04_03_point1 >= dM_04_03_ctrpt);
wire signed [10:0] dM_04_03_point2 = dM [219:209];
assign dM_04_03_comp[2] = (dM_04_03_point2 >= dM_04_03_ctrpt);
wire signed [10:0] dM_04_03_point3 = dM [285:275];
assign dM_04_03_comp[3] = (dM_04_03_point3 >= dM_04_03_ctrpt);
wire signed [10:0] dM_04_03_point4 = dM [307:297];
assign dM_04_03_comp[4] = (dM_04_03_point4 >= dM_04_03_ctrpt);
wire signed [10:0] dM_04_03_point5 = dM [373:363];
assign dM_04_03_comp[5] = (dM_04_03_point5 >= dM_04_03_ctrpt);
wire signed [10:0] dM_04_03_point6 = dM [384:374];
assign dM_04_03_comp[6] = (dM_04_03_point6 >= dM_04_03_ctrpt);
wire signed [10:0] dM_04_03_point7 = dM [395:385];
assign dM_04_03_comp[7] = (dM_04_03_point7 >= dM_04_03_ctrpt);
wire signed [10:0] dM_04_03_MINDET;
assign dM_04_03_MINDET = dM [296:286];
assign dM_04_03_comp[8] = (dM_04_03_MINDET < MIN_DET);
assign islocalmin[13] =	&dM_04_03_comp;


wire [8:0] dM_05_03_comp;
wire signed [10:0] dM_05_03_ctrpt = dM [384:374];
wire signed [10:0] dM_05_03_point0 = dM [285:275];
assign dM_05_03_comp[0] = (dM_05_03_point0 >= dM_05_03_ctrpt);
wire signed [10:0] dM_05_03_point1 = dM [296:286];
assign dM_05_03_comp[1] = (dM_05_03_point1 >= dM_05_03_ctrpt);
wire signed [10:0] dM_05_03_point2 = dM [307:297];
assign dM_05_03_comp[2] = (dM_05_03_point2 >= dM_05_03_ctrpt);
wire signed [10:0] dM_05_03_point3 = dM [373:363];
assign dM_05_03_comp[3] = (dM_05_03_point3 >= dM_05_03_ctrpt);
wire signed [10:0] dM_05_03_point4 = dM [395:385];
assign dM_05_03_comp[4] = (dM_05_03_point4 >= dM_05_03_ctrpt);
wire signed [10:0] dM_05_03_point5 = dM [461:451];
assign dM_05_03_comp[5] = (dM_05_03_point5 >= dM_05_03_ctrpt);
wire signed [10:0] dM_05_03_point6 = dM [472:462];
assign dM_05_03_comp[6] = (dM_05_03_point6 >= dM_05_03_ctrpt);
wire signed [10:0] dM_05_03_point7 = dM [483:473];
assign dM_05_03_comp[7] = (dM_05_03_point7 >= dM_05_03_ctrpt);
wire signed [10:0] dM_05_03_MINDET;
assign dM_05_03_MINDET = dM [384:374];
assign dM_05_03_comp[8] = (dM_05_03_MINDET < MIN_DET);
assign islocalmin[19] =	&dM_05_03_comp;


wire [8:0] dM_02_04_comp;
wire signed [10:0] dM_02_04_ctrpt = dM [131:121];
wire signed [10:0] dM_02_04_point0 = dM [32:22];
assign dM_02_04_comp[0] = (dM_02_04_point0 >= dM_02_04_ctrpt);
wire signed [10:0] dM_02_04_point1 = dM [43:33];
assign dM_02_04_comp[1] = (dM_02_04_point1 >= dM_02_04_ctrpt);
wire signed [10:0] dM_02_04_point2 = dM [54:44];
assign dM_02_04_comp[2] = (dM_02_04_point2 >= dM_02_04_ctrpt);
wire signed [10:0] dM_02_04_point3 = dM [120:110];
assign dM_02_04_comp[3] = (dM_02_04_point3 >= dM_02_04_ctrpt);
wire signed [10:0] dM_02_04_point4 = dM [142:132];
assign dM_02_04_comp[4] = (dM_02_04_point4 >= dM_02_04_ctrpt);
wire signed [10:0] dM_02_04_point5 = dM [208:198];
assign dM_02_04_comp[5] = (dM_02_04_point5 >= dM_02_04_ctrpt);
wire signed [10:0] dM_02_04_point6 = dM [219:209];
assign dM_02_04_comp[6] = (dM_02_04_point6 >= dM_02_04_ctrpt);
wire signed [10:0] dM_02_04_point7 = dM [230:220];
assign dM_02_04_comp[7] = (dM_02_04_point7 >= dM_02_04_ctrpt);
wire signed [10:0] dM_02_04_MINDET;
assign dM_02_04_MINDET = dM [131:121];
assign dM_02_04_comp[8] = (dM_02_04_MINDET < MIN_DET);
assign islocalmin[2] =	&dM_02_04_comp;


wire [8:0] dM_03_04_comp;
wire signed [10:0] dM_03_04_ctrpt = dM [219:209];
wire signed [10:0] dM_03_04_point0 = dM [120:110];
assign dM_03_04_comp[0] = (dM_03_04_point0 >= dM_03_04_ctrpt);
wire signed [10:0] dM_03_04_point1 = dM [131:121];
assign dM_03_04_comp[1] = (dM_03_04_point1 >= dM_03_04_ctrpt);
wire signed [10:0] dM_03_04_point2 = dM [142:132];
assign dM_03_04_comp[2] = (dM_03_04_point2 >= dM_03_04_ctrpt);
wire signed [10:0] dM_03_04_point3 = dM [208:198];
assign dM_03_04_comp[3] = (dM_03_04_point3 >= dM_03_04_ctrpt);
wire signed [10:0] dM_03_04_point4 = dM [230:220];
assign dM_03_04_comp[4] = (dM_03_04_point4 >= dM_03_04_ctrpt);
wire signed [10:0] dM_03_04_point5 = dM [296:286];
assign dM_03_04_comp[5] = (dM_03_04_point5 >= dM_03_04_ctrpt);
wire signed [10:0] dM_03_04_point6 = dM [307:297];
assign dM_03_04_comp[6] = (dM_03_04_point6 >= dM_03_04_ctrpt);
wire signed [10:0] dM_03_04_point7 = dM [318:308];
assign dM_03_04_comp[7] = (dM_03_04_point7 >= dM_03_04_ctrpt);
wire signed [10:0] dM_03_04_MINDET;
assign dM_03_04_MINDET = dM [219:209];
assign dM_03_04_comp[8] = (dM_03_04_MINDET < MIN_DET);
assign islocalmin[8] =	&dM_03_04_comp;


wire [8:0] dM_04_04_comp;
wire signed [10:0] dM_04_04_ctrpt = dM [307:297];
wire signed [10:0] dM_04_04_point0 = dM [208:198];
assign dM_04_04_comp[0] = (dM_04_04_point0 >= dM_04_04_ctrpt);
wire signed [10:0] dM_04_04_point1 = dM [219:209];
assign dM_04_04_comp[1] = (dM_04_04_point1 >= dM_04_04_ctrpt);
wire signed [10:0] dM_04_04_point2 = dM [230:220];
assign dM_04_04_comp[2] = (dM_04_04_point2 >= dM_04_04_ctrpt);
wire signed [10:0] dM_04_04_point3 = dM [296:286];
assign dM_04_04_comp[3] = (dM_04_04_point3 >= dM_04_04_ctrpt);
wire signed [10:0] dM_04_04_point4 = dM [318:308];
assign dM_04_04_comp[4] = (dM_04_04_point4 >= dM_04_04_ctrpt);
wire signed [10:0] dM_04_04_point5 = dM [384:374];
assign dM_04_04_comp[5] = (dM_04_04_point5 >= dM_04_04_ctrpt);
wire signed [10:0] dM_04_04_point6 = dM [395:385];
assign dM_04_04_comp[6] = (dM_04_04_point6 >= dM_04_04_ctrpt);
wire signed [10:0] dM_04_04_point7 = dM [406:396];
assign dM_04_04_comp[7] = (dM_04_04_point7 >= dM_04_04_ctrpt);
wire signed [10:0] dM_04_04_MINDET;
assign dM_04_04_MINDET = dM [307:297];
assign dM_04_04_comp[8] = (dM_04_04_MINDET < MIN_DET);
assign islocalmin[14] =	&dM_04_04_comp;


wire [8:0] dM_05_04_comp;
wire signed [10:0] dM_05_04_ctrpt = dM [395:385];
wire signed [10:0] dM_05_04_point0 = dM [296:286];
assign dM_05_04_comp[0] = (dM_05_04_point0 >= dM_05_04_ctrpt);
wire signed [10:0] dM_05_04_point1 = dM [307:297];
assign dM_05_04_comp[1] = (dM_05_04_point1 >= dM_05_04_ctrpt);
wire signed [10:0] dM_05_04_point2 = dM [318:308];
assign dM_05_04_comp[2] = (dM_05_04_point2 >= dM_05_04_ctrpt);
wire signed [10:0] dM_05_04_point3 = dM [384:374];
assign dM_05_04_comp[3] = (dM_05_04_point3 >= dM_05_04_ctrpt);
wire signed [10:0] dM_05_04_point4 = dM [406:396];
assign dM_05_04_comp[4] = (dM_05_04_point4 >= dM_05_04_ctrpt);
wire signed [10:0] dM_05_04_point5 = dM [472:462];
assign dM_05_04_comp[5] = (dM_05_04_point5 >= dM_05_04_ctrpt);
wire signed [10:0] dM_05_04_point6 = dM [483:473];
assign dM_05_04_comp[6] = (dM_05_04_point6 >= dM_05_04_ctrpt);
wire signed [10:0] dM_05_04_point7 = dM [494:484];
assign dM_05_04_comp[7] = (dM_05_04_point7 >= dM_05_04_ctrpt);
wire signed [10:0] dM_05_04_MINDET;
assign dM_05_04_MINDET = dM [395:385];
assign dM_05_04_comp[8] = (dM_05_04_MINDET < MIN_DET);
assign islocalmin[20] =	&dM_05_04_comp;


wire [8:0] dM_02_05_comp;
wire signed [10:0] dM_02_05_ctrpt = dM [142:132];
wire signed [10:0] dM_02_05_point0 = dM [43:33];
assign dM_02_05_comp[0] = (dM_02_05_point0 >= dM_02_05_ctrpt);
wire signed [10:0] dM_02_05_point1 = dM [54:44];
assign dM_02_05_comp[1] = (dM_02_05_point1 >= dM_02_05_ctrpt);
wire signed [10:0] dM_02_05_point2 = dM [65:55];
assign dM_02_05_comp[2] = (dM_02_05_point2 >= dM_02_05_ctrpt);
wire signed [10:0] dM_02_05_point3 = dM [131:121];
assign dM_02_05_comp[3] = (dM_02_05_point3 >= dM_02_05_ctrpt);
wire signed [10:0] dM_02_05_point4 = dM [153:143];
assign dM_02_05_comp[4] = (dM_02_05_point4 >= dM_02_05_ctrpt);
wire signed [10:0] dM_02_05_point5 = dM [219:209];
assign dM_02_05_comp[5] = (dM_02_05_point5 >= dM_02_05_ctrpt);
wire signed [10:0] dM_02_05_point6 = dM [230:220];
assign dM_02_05_comp[6] = (dM_02_05_point6 >= dM_02_05_ctrpt);
wire signed [10:0] dM_02_05_point7 = dM [241:231];
assign dM_02_05_comp[7] = (dM_02_05_point7 >= dM_02_05_ctrpt);
wire signed [10:0] dM_02_05_MINDET;
assign dM_02_05_MINDET = dM [142:132];
assign dM_02_05_comp[8] = (dM_02_05_MINDET < MIN_DET);
assign islocalmin[3] =	&dM_02_05_comp;


wire [8:0] dM_03_05_comp;
wire signed [10:0] dM_03_05_ctrpt = dM [230:220];
wire signed [10:0] dM_03_05_point0 = dM [131:121];
assign dM_03_05_comp[0] = (dM_03_05_point0 >= dM_03_05_ctrpt);
wire signed [10:0] dM_03_05_point1 = dM [142:132];
assign dM_03_05_comp[1] = (dM_03_05_point1 >= dM_03_05_ctrpt);
wire signed [10:0] dM_03_05_point2 = dM [153:143];
assign dM_03_05_comp[2] = (dM_03_05_point2 >= dM_03_05_ctrpt);
wire signed [10:0] dM_03_05_point3 = dM [219:209];
assign dM_03_05_comp[3] = (dM_03_05_point3 >= dM_03_05_ctrpt);
wire signed [10:0] dM_03_05_point4 = dM [241:231];
assign dM_03_05_comp[4] = (dM_03_05_point4 >= dM_03_05_ctrpt);
wire signed [10:0] dM_03_05_point5 = dM [307:297];
assign dM_03_05_comp[5] = (dM_03_05_point5 >= dM_03_05_ctrpt);
wire signed [10:0] dM_03_05_point6 = dM [318:308];
assign dM_03_05_comp[6] = (dM_03_05_point6 >= dM_03_05_ctrpt);
wire signed [10:0] dM_03_05_point7 = dM [329:319];
assign dM_03_05_comp[7] = (dM_03_05_point7 >= dM_03_05_ctrpt);
wire signed [10:0] dM_03_05_MINDET;
assign dM_03_05_MINDET = dM [230:220];
assign dM_03_05_comp[8] = (dM_03_05_MINDET < MIN_DET);
assign islocalmin[9] =	&dM_03_05_comp;


wire [8:0] dM_04_05_comp;
wire signed [10:0] dM_04_05_ctrpt = dM [318:308];
wire signed [10:0] dM_04_05_point0 = dM [219:209];
assign dM_04_05_comp[0] = (dM_04_05_point0 >= dM_04_05_ctrpt);
wire signed [10:0] dM_04_05_point1 = dM [230:220];
assign dM_04_05_comp[1] = (dM_04_05_point1 >= dM_04_05_ctrpt);
wire signed [10:0] dM_04_05_point2 = dM [241:231];
assign dM_04_05_comp[2] = (dM_04_05_point2 >= dM_04_05_ctrpt);
wire signed [10:0] dM_04_05_point3 = dM [307:297];
assign dM_04_05_comp[3] = (dM_04_05_point3 >= dM_04_05_ctrpt);
wire signed [10:0] dM_04_05_point4 = dM [329:319];
assign dM_04_05_comp[4] = (dM_04_05_point4 >= dM_04_05_ctrpt);
wire signed [10:0] dM_04_05_point5 = dM [395:385];
assign dM_04_05_comp[5] = (dM_04_05_point5 >= dM_04_05_ctrpt);
wire signed [10:0] dM_04_05_point6 = dM [406:396];
assign dM_04_05_comp[6] = (dM_04_05_point6 >= dM_04_05_ctrpt);
wire signed [10:0] dM_04_05_point7 = dM [417:407];
assign dM_04_05_comp[7] = (dM_04_05_point7 >= dM_04_05_ctrpt);
wire signed [10:0] dM_04_05_MINDET;
assign dM_04_05_MINDET = dM [318:308];
assign dM_04_05_comp[8] = (dM_04_05_MINDET < MIN_DET);
assign islocalmin[15] =	&dM_04_05_comp;


wire [8:0] dM_05_05_comp;
wire signed [10:0] dM_05_05_ctrpt = dM [406:396];
wire signed [10:0] dM_05_05_point0 = dM [307:297];
assign dM_05_05_comp[0] = (dM_05_05_point0 >= dM_05_05_ctrpt);
wire signed [10:0] dM_05_05_point1 = dM [318:308];
assign dM_05_05_comp[1] = (dM_05_05_point1 >= dM_05_05_ctrpt);
wire signed [10:0] dM_05_05_point2 = dM [329:319];
assign dM_05_05_comp[2] = (dM_05_05_point2 >= dM_05_05_ctrpt);
wire signed [10:0] dM_05_05_point3 = dM [395:385];
assign dM_05_05_comp[3] = (dM_05_05_point3 >= dM_05_05_ctrpt);
wire signed [10:0] dM_05_05_point4 = dM [417:407];
assign dM_05_05_comp[4] = (dM_05_05_point4 >= dM_05_05_ctrpt);
wire signed [10:0] dM_05_05_point5 = dM [483:473];
assign dM_05_05_comp[5] = (dM_05_05_point5 >= dM_05_05_ctrpt);
wire signed [10:0] dM_05_05_point6 = dM [494:484];
assign dM_05_05_comp[6] = (dM_05_05_point6 >= dM_05_05_ctrpt);
wire signed [10:0] dM_05_05_point7 = dM [505:495];
assign dM_05_05_comp[7] = (dM_05_05_point7 >= dM_05_05_ctrpt);
wire signed [10:0] dM_05_05_MINDET;
assign dM_05_05_MINDET = dM [406:396];
assign dM_05_05_comp[8] = (dM_05_05_MINDET < MIN_DET);
assign islocalmin[21] =	&dM_05_05_comp;


wire [8:0] dM_02_06_comp;
wire signed [10:0] dM_02_06_ctrpt = dM [153:143];
wire signed [10:0] dM_02_06_point0 = dM [54:44];
assign dM_02_06_comp[0] = (dM_02_06_point0 >= dM_02_06_ctrpt);
wire signed [10:0] dM_02_06_point1 = dM [65:55];
assign dM_02_06_comp[1] = (dM_02_06_point1 >= dM_02_06_ctrpt);
wire signed [10:0] dM_02_06_point2 = dM [76:66];
assign dM_02_06_comp[2] = (dM_02_06_point2 >= dM_02_06_ctrpt);
wire signed [10:0] dM_02_06_point3 = dM [142:132];
assign dM_02_06_comp[3] = (dM_02_06_point3 >= dM_02_06_ctrpt);
wire signed [10:0] dM_02_06_point4 = dM [164:154];
assign dM_02_06_comp[4] = (dM_02_06_point4 >= dM_02_06_ctrpt);
wire signed [10:0] dM_02_06_point5 = dM [230:220];
assign dM_02_06_comp[5] = (dM_02_06_point5 >= dM_02_06_ctrpt);
wire signed [10:0] dM_02_06_point6 = dM [241:231];
assign dM_02_06_comp[6] = (dM_02_06_point6 >= dM_02_06_ctrpt);
wire signed [10:0] dM_02_06_point7 = dM [252:242];
assign dM_02_06_comp[7] = (dM_02_06_point7 >= dM_02_06_ctrpt);
wire signed [10:0] dM_02_06_MINDET;
assign dM_02_06_MINDET = dM [153:143];
assign dM_02_06_comp[8] = (dM_02_06_MINDET < MIN_DET);
assign islocalmin[4] =	&dM_02_06_comp;


wire [8:0] dM_03_06_comp;
wire signed [10:0] dM_03_06_ctrpt = dM [241:231];
wire signed [10:0] dM_03_06_point0 = dM [142:132];
assign dM_03_06_comp[0] = (dM_03_06_point0 >= dM_03_06_ctrpt);
wire signed [10:0] dM_03_06_point1 = dM [153:143];
assign dM_03_06_comp[1] = (dM_03_06_point1 >= dM_03_06_ctrpt);
wire signed [10:0] dM_03_06_point2 = dM [164:154];
assign dM_03_06_comp[2] = (dM_03_06_point2 >= dM_03_06_ctrpt);
wire signed [10:0] dM_03_06_point3 = dM [230:220];
assign dM_03_06_comp[3] = (dM_03_06_point3 >= dM_03_06_ctrpt);
wire signed [10:0] dM_03_06_point4 = dM [252:242];
assign dM_03_06_comp[4] = (dM_03_06_point4 >= dM_03_06_ctrpt);
wire signed [10:0] dM_03_06_point5 = dM [318:308];
assign dM_03_06_comp[5] = (dM_03_06_point5 >= dM_03_06_ctrpt);
wire signed [10:0] dM_03_06_point6 = dM [329:319];
assign dM_03_06_comp[6] = (dM_03_06_point6 >= dM_03_06_ctrpt);
wire signed [10:0] dM_03_06_point7 = dM [340:330];
assign dM_03_06_comp[7] = (dM_03_06_point7 >= dM_03_06_ctrpt);
wire signed [10:0] dM_03_06_MINDET;
assign dM_03_06_MINDET = dM [241:231];
assign dM_03_06_comp[8] = (dM_03_06_MINDET < MIN_DET);
assign islocalmin[10] =	&dM_03_06_comp;


wire [8:0] dM_04_06_comp;
wire signed [10:0] dM_04_06_ctrpt = dM [329:319];
wire signed [10:0] dM_04_06_point0 = dM [230:220];
assign dM_04_06_comp[0] = (dM_04_06_point0 >= dM_04_06_ctrpt);
wire signed [10:0] dM_04_06_point1 = dM [241:231];
assign dM_04_06_comp[1] = (dM_04_06_point1 >= dM_04_06_ctrpt);
wire signed [10:0] dM_04_06_point2 = dM [252:242];
assign dM_04_06_comp[2] = (dM_04_06_point2 >= dM_04_06_ctrpt);
wire signed [10:0] dM_04_06_point3 = dM [318:308];
assign dM_04_06_comp[3] = (dM_04_06_point3 >= dM_04_06_ctrpt);
wire signed [10:0] dM_04_06_point4 = dM [340:330];
assign dM_04_06_comp[4] = (dM_04_06_point4 >= dM_04_06_ctrpt);
wire signed [10:0] dM_04_06_point5 = dM [406:396];
assign dM_04_06_comp[5] = (dM_04_06_point5 >= dM_04_06_ctrpt);
wire signed [10:0] dM_04_06_point6 = dM [417:407];
assign dM_04_06_comp[6] = (dM_04_06_point6 >= dM_04_06_ctrpt);
wire signed [10:0] dM_04_06_point7 = dM [428:418];
assign dM_04_06_comp[7] = (dM_04_06_point7 >= dM_04_06_ctrpt);
wire signed [10:0] dM_04_06_MINDET;
assign dM_04_06_MINDET = dM [329:319];
assign dM_04_06_comp[8] = (dM_04_06_MINDET < MIN_DET);
assign islocalmin[16] =	&dM_04_06_comp;


wire [8:0] dM_05_06_comp;
wire signed [10:0] dM_05_06_ctrpt = dM [417:407];
wire signed [10:0] dM_05_06_point0 = dM [318:308];
assign dM_05_06_comp[0] = (dM_05_06_point0 >= dM_05_06_ctrpt);
wire signed [10:0] dM_05_06_point1 = dM [329:319];
assign dM_05_06_comp[1] = (dM_05_06_point1 >= dM_05_06_ctrpt);
wire signed [10:0] dM_05_06_point2 = dM [340:330];
assign dM_05_06_comp[2] = (dM_05_06_point2 >= dM_05_06_ctrpt);
wire signed [10:0] dM_05_06_point3 = dM [406:396];
assign dM_05_06_comp[3] = (dM_05_06_point3 >= dM_05_06_ctrpt);
wire signed [10:0] dM_05_06_point4 = dM [428:418];
assign dM_05_06_comp[4] = (dM_05_06_point4 >= dM_05_06_ctrpt);
wire signed [10:0] dM_05_06_point5 = dM [494:484];
assign dM_05_06_comp[5] = (dM_05_06_point5 >= dM_05_06_ctrpt);
wire signed [10:0] dM_05_06_point6 = dM [505:495];
assign dM_05_06_comp[6] = (dM_05_06_point6 >= dM_05_06_ctrpt);
wire signed [10:0] dM_05_06_point7 = dM [516:506];
assign dM_05_06_comp[7] = (dM_05_06_point7 >= dM_05_06_ctrpt);
wire signed [10:0] dM_05_06_MINDET;
assign dM_05_06_MINDET = dM [417:407];
assign dM_05_06_comp[8] = (dM_05_06_MINDET < MIN_DET);
assign islocalmin[22] =	&dM_05_06_comp;


wire [8:0] dM_02_07_comp;
wire signed [10:0] dM_02_07_ctrpt = dM [164:154];
wire signed [10:0] dM_02_07_point0 = dM [65:55];
assign dM_02_07_comp[0] = (dM_02_07_point0 >= dM_02_07_ctrpt);
wire signed [10:0] dM_02_07_point1 = dM [76:66];
assign dM_02_07_comp[1] = (dM_02_07_point1 >= dM_02_07_ctrpt);
wire signed [10:0] dM_02_07_point2 = dM [87:77];
assign dM_02_07_comp[2] = (dM_02_07_point2 >= dM_02_07_ctrpt);
wire signed [10:0] dM_02_07_point3 = dM [153:143];
assign dM_02_07_comp[3] = (dM_02_07_point3 >= dM_02_07_ctrpt);
wire signed [10:0] dM_02_07_point4 = dM [175:165];
assign dM_02_07_comp[4] = (dM_02_07_point4 >= dM_02_07_ctrpt);
wire signed [10:0] dM_02_07_point5 = dM [241:231];
assign dM_02_07_comp[5] = (dM_02_07_point5 >= dM_02_07_ctrpt);
wire signed [10:0] dM_02_07_point6 = dM [252:242];
assign dM_02_07_comp[6] = (dM_02_07_point6 >= dM_02_07_ctrpt);
wire signed [10:0] dM_02_07_point7 = dM [263:253];
assign dM_02_07_comp[7] = (dM_02_07_point7 >= dM_02_07_ctrpt);
wire signed [10:0] dM_02_07_MINDET;
assign dM_02_07_MINDET = dM [164:154];
assign dM_02_07_comp[8] = (dM_02_07_MINDET < MIN_DET);
assign islocalmin[5] =	&dM_02_07_comp;


wire [8:0] dM_03_07_comp;
wire signed [10:0] dM_03_07_ctrpt = dM [252:242];
wire signed [10:0] dM_03_07_point0 = dM [153:143];
assign dM_03_07_comp[0] = (dM_03_07_point0 >= dM_03_07_ctrpt);
wire signed [10:0] dM_03_07_point1 = dM [164:154];
assign dM_03_07_comp[1] = (dM_03_07_point1 >= dM_03_07_ctrpt);
wire signed [10:0] dM_03_07_point2 = dM [175:165];
assign dM_03_07_comp[2] = (dM_03_07_point2 >= dM_03_07_ctrpt);
wire signed [10:0] dM_03_07_point3 = dM [241:231];
assign dM_03_07_comp[3] = (dM_03_07_point3 >= dM_03_07_ctrpt);
wire signed [10:0] dM_03_07_point4 = dM [263:253];
assign dM_03_07_comp[4] = (dM_03_07_point4 >= dM_03_07_ctrpt);
wire signed [10:0] dM_03_07_point5 = dM [329:319];
assign dM_03_07_comp[5] = (dM_03_07_point5 >= dM_03_07_ctrpt);
wire signed [10:0] dM_03_07_point6 = dM [340:330];
assign dM_03_07_comp[6] = (dM_03_07_point6 >= dM_03_07_ctrpt);
wire signed [10:0] dM_03_07_point7 = dM [351:341];
assign dM_03_07_comp[7] = (dM_03_07_point7 >= dM_03_07_ctrpt);
wire signed [10:0] dM_03_07_MINDET;
assign dM_03_07_MINDET = dM [252:242];
assign dM_03_07_comp[8] = (dM_03_07_MINDET < MIN_DET);
assign islocalmin[11] =	&dM_03_07_comp;


wire [8:0] dM_04_07_comp;
wire signed [10:0] dM_04_07_ctrpt = dM [340:330];
wire signed [10:0] dM_04_07_point0 = dM [241:231];
assign dM_04_07_comp[0] = (dM_04_07_point0 >= dM_04_07_ctrpt);
wire signed [10:0] dM_04_07_point1 = dM [252:242];
assign dM_04_07_comp[1] = (dM_04_07_point1 >= dM_04_07_ctrpt);
wire signed [10:0] dM_04_07_point2 = dM [263:253];
assign dM_04_07_comp[2] = (dM_04_07_point2 >= dM_04_07_ctrpt);
wire signed [10:0] dM_04_07_point3 = dM [329:319];
assign dM_04_07_comp[3] = (dM_04_07_point3 >= dM_04_07_ctrpt);
wire signed [10:0] dM_04_07_point4 = dM [351:341];
assign dM_04_07_comp[4] = (dM_04_07_point4 >= dM_04_07_ctrpt);
wire signed [10:0] dM_04_07_point5 = dM [417:407];
assign dM_04_07_comp[5] = (dM_04_07_point5 >= dM_04_07_ctrpt);
wire signed [10:0] dM_04_07_point6 = dM [428:418];
assign dM_04_07_comp[6] = (dM_04_07_point6 >= dM_04_07_ctrpt);
wire signed [10:0] dM_04_07_point7 = dM [439:429];
assign dM_04_07_comp[7] = (dM_04_07_point7 >= dM_04_07_ctrpt);
wire signed [10:0] dM_04_07_MINDET;
assign dM_04_07_MINDET = dM [340:330];
assign dM_04_07_comp[8] = (dM_04_07_MINDET < MIN_DET);
assign islocalmin[17] =	&dM_04_07_comp;


wire [8:0] dM_05_07_comp;
wire signed [10:0] dM_05_07_ctrpt = dM [428:418];
wire signed [10:0] dM_05_07_point0 = dM [329:319];
assign dM_05_07_comp[0] = (dM_05_07_point0 >= dM_05_07_ctrpt);
wire signed [10:0] dM_05_07_point1 = dM [340:330];
assign dM_05_07_comp[1] = (dM_05_07_point1 >= dM_05_07_ctrpt);
wire signed [10:0] dM_05_07_point2 = dM [351:341];
assign dM_05_07_comp[2] = (dM_05_07_point2 >= dM_05_07_ctrpt);
wire signed [10:0] dM_05_07_point3 = dM [417:407];
assign dM_05_07_comp[3] = (dM_05_07_point3 >= dM_05_07_ctrpt);
wire signed [10:0] dM_05_07_point4 = dM [439:429];
assign dM_05_07_comp[4] = (dM_05_07_point4 >= dM_05_07_ctrpt);
wire signed [10:0] dM_05_07_point5 = dM [505:495];
assign dM_05_07_comp[5] = (dM_05_07_point5 >= dM_05_07_ctrpt);
wire signed [10:0] dM_05_07_point6 = dM [516:506];
assign dM_05_07_comp[6] = (dM_05_07_point6 >= dM_05_07_ctrpt);
wire signed [10:0] dM_05_07_point7 = dM [527:517];
assign dM_05_07_comp[7] = (dM_05_07_point7 >= dM_05_07_ctrpt);
wire signed [10:0] dM_05_07_MINDET;
assign dM_05_07_MINDET = dM [428:418];
assign dM_05_07_comp[8] = (dM_05_07_MINDET < MIN_DET);
assign islocalmin[23] =	&dM_05_07_comp;

endmodule
