`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    15:45:19 03/13/2008 
// Design Name: 
// Module Name:    point_iszero 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
/*
This module takes as input one point in the standard coordinates, as described below:


First nine bits are the n coordinate (rows.) Next ten bits are the m
coordinate (columns.) These are stored little endian.
32-bit register
0      78 9     15 18    23       31
|------|| ------||------| |------|
[   n   ] [    m   ] 
LSB   MSB LSB	  MSB 

pointn = BRAM_data [8:0]
pointm = BRAM_data [18:9]


The point is then evaluated, if it is zero, a flag is raised.
*/
module point_iszero(	point,
							iszero
							);
input 	[31:0] 	point;
output 				iszero;



assign iszero = ~(point[18] || point[17] || point[16] || point[15] || point[14] || point[13] ||
					 point[12] || point[11] || point[10] || point[9]  || point[8]  || point[7]  ||
					 point[6]  || point[5]  || point[4]  || point[3]  || point[2]  || point[1]  ||
					 point[0]);
endmodule
