`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    20:18:25 03/01/2008 
// Design Name: 
// Module Name:    twos_comp_finder 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////

/* This module is part of the two's complement module, which finds the two's
complement of a number. It operates by the right-to-left complement method
as described in Brown & Vranesic, pg. 243. */

module twos_comp_finder10(
								op,		//input operator for invert to be found
								found	//found array, gives map of bits to be complemented
								);

	parameter NUM_BITS = 10;
								
	output [NUM_BITS-1:0] found;
	input [NUM_BITS-1:0] op;							

	//consider using a generate statement here?		
	assign found[0] = 0;
	assign found[1] = op[0];
	assign found[2] = op[1]&(~op[0]) | found[1];
	assign found[3] = op[2]&(~op[1]&~op[0]) | found[2];
	assign found[4] = op[3]&(~op[2]&~op[1]&~op[0]) | found[3];	
	assign found[5] = op[4]&(~op[3]&~op[2]&~op[1]&~op[0]) | found[4];
	assign found[6] = op[5]&(~op[4]&~op[3]&~op[2]&~op[1]&~op[0]) | found[5];	
	assign found[7] = op[6]&(~op[5]&~op[4]&~op[3]&~op[2]&~op[1]&~op[0]) | found[6];

	assign found[8]  = op[7]&(~op[6]&~op[5]&~op[4]&~op[3]&~op[2]&~op[1]&~op[0]) | found[7];
	assign found[9]  = op[8]&(~op[7]&~op[6]&~op[5]&~op[4]&~op[3]&~op[2]&~op[1]&~op[0]) | found[8];
	//assign found[10] = op[9]&(~op[8]&~op[7]&~op[6]&~op[5]&~op[4]&~op[3]&~op[2]&~op[1]&~op[0]) | found[9];
	//assign found[11] = op[10]&(~op[9]&~op[8]&~op[7]&~op[6]&~op[5]&~op[4]&~op[3]&~op[2]&~op[1]&~op[0]) | found[10];

endmodule
