//////////////////////////////////////////////////////////////////////////////
// Filename:          C:\Skule\ECE532\HDL2\EDK_repository\MyProcessorIPLib/drivers/bplbaccess_v1_01_a/src/bplbaccess.h
// Version:           1.01.a
// Description:       bplbaccess Driver Header File
// Date:              Thu Mar 20 17:24:53 2008 (by Create and Import Peripheral Wizard)
//////////////////////////////////////////////////////////////////////////////

#ifndef BPLBACCESS_H
#define BPLBACCESS_H

/***************************** Include Files *******************************/

#include "xbasic_types.h"
#include "xstatus.h"
#include "xio.h"

/************************** Constant Definitions ***************************/


/**
 * User Logic Slave Space Offsets
 * -- SLAVE_REG0 : user logic slave module register 0
 * -- SLAVE_REG1 : user logic slave module register 1
 * -- SLAVE_REG2 : user logic slave module register 2
 * -- SLAVE_REG3 : user logic slave module register 3
 * -- SLAVE_REG4 : user logic slave module register 4
 * -- SLAVE_REG5 : user logic slave module register 5
 * -- SLAVE_REG6 : user logic slave module register 6
 * -- SLAVE_REG7 : user logic slave module register 7
 * -- SLAVE_REG8 : user logic slave module register 8
 * -- SLAVE_REG9 : user logic slave module register 9
 * -- SLAVE_REG10 : user logic slave module register 10
 * -- SLAVE_REG11 : user logic slave module register 11
 * -- SLAVE_REG12 : user logic slave module register 12
 * -- SLAVE_REG13 : user logic slave module register 13
 * -- SLAVE_REG14 : user logic slave module register 14
 * -- SLAVE_REG15 : user logic slave module register 15
 */
#define BPLBACCESS_USER_SLAVE_SPACE_OFFSET (0x00000000)
#define BPLBACCESS_SLAVE_REG0_OFFSET (BPLBACCESS_USER_SLAVE_SPACE_OFFSET + 0x00000000)
#define BPLBACCESS_SLAVE_REG1_OFFSET (BPLBACCESS_USER_SLAVE_SPACE_OFFSET + 0x00000008)
#define BPLBACCESS_SLAVE_REG2_OFFSET (BPLBACCESS_USER_SLAVE_SPACE_OFFSET + 0x00000010)
#define BPLBACCESS_SLAVE_REG3_OFFSET (BPLBACCESS_USER_SLAVE_SPACE_OFFSET + 0x00000018)
#define BPLBACCESS_SLAVE_REG4_OFFSET (BPLBACCESS_USER_SLAVE_SPACE_OFFSET + 0x00000020)
#define BPLBACCESS_SLAVE_REG5_OFFSET (BPLBACCESS_USER_SLAVE_SPACE_OFFSET + 0x00000028)
#define BPLBACCESS_SLAVE_REG6_OFFSET (BPLBACCESS_USER_SLAVE_SPACE_OFFSET + 0x00000030)
#define BPLBACCESS_SLAVE_REG7_OFFSET (BPLBACCESS_USER_SLAVE_SPACE_OFFSET + 0x00000038)
#define BPLBACCESS_SLAVE_REG8_OFFSET (BPLBACCESS_USER_SLAVE_SPACE_OFFSET + 0x00000040)
#define BPLBACCESS_SLAVE_REG9_OFFSET (BPLBACCESS_USER_SLAVE_SPACE_OFFSET + 0x00000048)
#define BPLBACCESS_SLAVE_REG10_OFFSET (BPLBACCESS_USER_SLAVE_SPACE_OFFSET + 0x00000050)
#define BPLBACCESS_SLAVE_REG11_OFFSET (BPLBACCESS_USER_SLAVE_SPACE_OFFSET + 0x00000058)
#define BPLBACCESS_SLAVE_REG12_OFFSET (BPLBACCESS_USER_SLAVE_SPACE_OFFSET + 0x00000060)
#define BPLBACCESS_SLAVE_REG13_OFFSET (BPLBACCESS_USER_SLAVE_SPACE_OFFSET + 0x00000068)
#define BPLBACCESS_SLAVE_REG14_OFFSET (BPLBACCESS_USER_SLAVE_SPACE_OFFSET + 0x00000070)
#define BPLBACCESS_SLAVE_REG15_OFFSET (BPLBACCESS_USER_SLAVE_SPACE_OFFSET + 0x00000078)

/**
 * User Logic Master Space Offsets
 * -- MASTER_CR      : user logic master module control register
 * -- MASTER_SR      : user logic master module status register
 * -- MASTER_LA      : user logic master module local address (IP2IP_Addr) register
 * -- MASTER_RA      : user logic master module remote address (IP2Bus_Addr) register
 * -- MASTER_LENGTH  : user logic master module data transfer length (bytes) register
 * -- MASTER_BE      : user logic master module byte enable register
 * -- MASTER_GO_PORT : user logic master module go bit (to start master operation)
 */
#define BPLBACCESS_USER_MASTER_SPACE_OFFSET (0x00000100)
#define BPLBACCESS_MASTER_CR_OFFSET (BPLBACCESS_USER_MASTER_SPACE_OFFSET + 0x00000000)
#define BPLBACCESS_MASTER_SR_OFFSET (BPLBACCESS_USER_MASTER_SPACE_OFFSET + 0x00000001)
#define BPLBACCESS_MASTER_LA_OFFSET (BPLBACCESS_USER_MASTER_SPACE_OFFSET + 0x00000004)
#define BPLBACCESS_MASTER_RA_OFFSET (BPLBACCESS_USER_MASTER_SPACE_OFFSET + 0x00000008)
#define BPLBACCESS_MASTER_LENGTH_OFFSET (BPLBACCESS_USER_MASTER_SPACE_OFFSET + 0x0000000C)
#define BPLBACCESS_MASTER_BE_OFFSET (BPLBACCESS_USER_MASTER_SPACE_OFFSET + 0x0000000E)
#define BPLBACCESS_MASTER_GO_PORT_OFFSET (BPLBACCESS_USER_MASTER_SPACE_OFFSET + 0x0000000F)

/**
 * User Logic Master Module Masks
 * -- MST_RD_MASK   : user logic master read request control
 * -- MST_WR_MASK   : user logic master write request control
 * -- MST_BL_MASK   : user logic master bus lock control
 * -- MST_BRST_MASK : user logic master burst assertion control
 * -- MST_DONE_MASK : user logic master transfer done status
 * -- MST_BSY_MASK  : user logic master busy status
 * -- MST_BRRD      : user logic master burst read request
 * -- MST_BRWR      : user logic master burst write request
 * -- MST_SGRD      : user logic master single read request
 * -- MST_SGWR      : user logic master single write request
 * -- MST_START     : user logic master to start transfer
 */
#define MST_RD_MASK (0x80000000UL)
#define MST_WR_MASK (0x40000000UL)
#define MST_BL_MASK (0x20000000UL)
#define MST_BRST_MASK (0x10000000UL)
#define MST_DONE_MASK (0x00800000UL)
#define MST_BSY_MASK (0x00400000UL)
#define MST_BRRD (0x90)
#define MST_BRWR (0x50)
#define MST_SGRD (0x80)
#define MST_SGWR (0x40)
#define MST_START (0x0A)

/**
 * IPIF Reset/Mir Space Register Offsets
 * -- RST : software reset register
 * -- MIR : module identification register
 */
#define BPLBACCESS_IPIF_RST_SPACE_OFFSET (0x00000200)
#define BPLBACCESS_RST_OFFSET (BPLBACCESS_IPIF_RST_SPACE_OFFSET + 0x00000000)
#define BPLBACCESS_MIR_OFFSET (BPLBACCESS_IPIF_RST_SPACE_OFFSET + 0x00000000)

/**
 * IPIF Reset/Mir Masks
 * -- IPIF_MAVN_MASK   : module major version number
 * -- IPIF_MIVN_MASK   : module minor version number
 * -- IPIF_MIVL_MASK   : module minor version letter
 * -- IPIF_BID_MASK    : module block id
 * -- IPIF_BTP_MASK    : module block type
 * -- IPIF_RESET       : software reset
 */
#define IPIF_MAVN_MASK (0xF0000000UL)
#define IPIF_MIVN_MASK (0x0FE00000UL)
#define IPIF_MIVL_MASK (0x001F0000UL)
#define IPIF_BID_MASK (0x0000FF00UL)
#define IPIF_BTP_MASK (0x000000FFUL)
#define IPIF_RESET (0x0000000A)

/**
 * IPIF Interrupt Controller Space Offsets
 * -- INTR_DISR  : device (ipif) interrupt status register
 * -- INTR_DIPR  : device (ipif) interrupt pending register
 * -- INTR_DIER  : device (ipif) interrupt enable register
 * -- INTR_DIIR  : device (ipif) interrupt id (priority encoder) register
 * -- INTR_DGIER : device (ipif) global interrupt enable register
 * -- INTR_ISR   : ip (user logic) interrupt status register
 * -- INTR_IER   : ip (user logic) interrupt enable register
 */
#define BPLBACCESS_IPIF_INTR_SPACE_OFFSET (0x00000300)
#define BPLBACCESS_INTR_DISR_OFFSET (BPLBACCESS_IPIF_INTR_SPACE_OFFSET + 0x00000000)
#define BPLBACCESS_INTR_DIPR_OFFSET (BPLBACCESS_IPIF_INTR_SPACE_OFFSET + 0x00000004)
#define BPLBACCESS_INTR_DIER_OFFSET (BPLBACCESS_IPIF_INTR_SPACE_OFFSET + 0x00000008)
#define BPLBACCESS_INTR_DIIR_OFFSET (BPLBACCESS_IPIF_INTR_SPACE_OFFSET + 0x00000018)
#define BPLBACCESS_INTR_DGIER_OFFSET (BPLBACCESS_IPIF_INTR_SPACE_OFFSET + 0x0000001C)
#define BPLBACCESS_INTR_ISR_OFFSET (BPLBACCESS_IPIF_INTR_SPACE_OFFSET + 0x00000020)
#define BPLBACCESS_INTR_IER_OFFSET (BPLBACCESS_IPIF_INTR_SPACE_OFFSET + 0x00000028)

/**
 * IPIF Interrupt Controller Masks
 * -- INTR_TERR_MASK : transaction error
 * -- INTR_DPTO_MASK : data phase time-out
 * -- INTR_IPIR_MASK : ip interrupt requeset
 * -- INTR_DMA0_MASK : dma channel 0 interrupt request
 * -- INTR_DMA1_MASK : dma channel 1 interrupt request
 * -- INTR_RFDL_MASK : read packet fifo deadlock interrupt request
 * -- INTR_WFDL_MASK : write packet fifo deadlock interrupt request
 * -- INTR_IID_MASK  : interrupt id
 * -- INTR_GIE_MASK  : global interrupt enable
 * -- INTR_NOPEND    : the DIPR has no pending interrupts
 */
#define INTR_TERR_MASK (0x00000001UL)
#define INTR_DPTO_MASK (0x00000002UL)
#define INTR_IPIR_MASK (0x00000004UL)
#define INTR_DMA0_MASK (0x00000008UL)
#define INTR_DMA1_MASK (0x00000010UL)
#define INTR_RFDL_MASK (0x00000020UL)
#define INTR_WFDL_MASK (0x00000040UL)
#define INTR_IID_MASK (0x000000FFUL)
#define INTR_GIE_MASK (0x80000000UL)
#define INTR_NOPEND (0x80)

/**
 * IPIF DMA & Scatter Gather Space Offsets
 * -- DMA0_RST    : dma & scatter gather channel 0 reset register
 * -- DMA0_MIR    : dma & scatter gather channel 0 module identification register
 * -- DMA0_DMACR  : dma & scatter gather channel 0 control register
 * -- DMA0_SA     : dma channel 0 source address register
 * -- DMA0_DA     : dma channel 0 destination address register
 * -- DMA0_LENGTH : dma channel 0 start/length register
 * -- DMA0_DMASR  : dma / scatter gather channel 0 status register
 * -- DMA0_BDA    : scatter gather channel 0 buffer descriptor address register
 * -- DMA0_SWCR   : scatter gather channel 0 software control register
 * -- DMA0_UPC    : scatter gather channel 0 unserviced packet count register
 * -- DMA0_PCT    : scatter gather channel 0 packet count threshold register
 * -- DMA0_PWB    : scatter gather channel 0 packet wait bound register
 * -- DMA0_ISR    : dma / scatter gather channel 0 interrupt status register
 * -- DMA0_IER    : dma / scatter gather channel 0 interrupt enable register
 * -- DMA1_RST    : dma & scatter gather channel 1 reset register
 * -- DMA1_MIR    : dma & scatter gather channel 1 module identification register
 * -- DMA1_DMACR  : dma & scatter gather channel 1 control register
 * -- DMA1_SA     : dma channel 1 source address register
 * -- DMA1_DA     : dma channel 1 destination address register
 * -- DMA1_LENGTH : dma channel 1 start/length register
 * -- DMA1_DMASR  : dma / scatter gather channel 1 status register
 * -- DMA1_BDA    : scatter gather channel 1 buffer descriptor address register
 * -- DMA1_SWCR   : scatter gather channel 1 software control register
 * -- DMA1_UPC    : scatter gather channel 1 unserviced packet count register
 * -- DMA1_PCT    : scatter gather channel 1 packet count threshold register
 * -- DMA1_PWB    : scatter gather channel 1 packet wait bound register
 * -- DMA1_ISR    : dma / scatter gather channel 1 interrupt status register
 * -- DMA1_IER    : dma / scatter gather channel 1 interrupt enable register
 */
#define BPLBACCESS_IPIF_DMA_SG_SPACE_OFFSET (0x00000400)
#define BPLBACCESS_DMA0_RST_OFFSET (BPLBACCESS_IPIF_DMA_SG_SPACE_OFFSET + 0x00000000)
#define BPLBACCESS_DMA0_MIR_OFFSET (BPLBACCESS_IPIF_DMA_SG_SPACE_OFFSET + 0x00000000)
#define BPLBACCESS_DMA0_DMACR_OFFSET (BPLBACCESS_IPIF_DMA_SG_SPACE_OFFSET + 0x00000004)
#define BPLBACCESS_DMA0_SA_OFFSET (BPLBACCESS_IPIF_DMA_SG_SPACE_OFFSET + 0x00000008)
#define BPLBACCESS_DMA0_DA_OFFSET (BPLBACCESS_IPIF_DMA_SG_SPACE_OFFSET + 0x0000000C)
#define BPLBACCESS_DMA0_LENGTH_OFFSET (BPLBACCESS_IPIF_DMA_SG_SPACE_OFFSET + 0x00000010)
#define BPLBACCESS_DMA0_DMASR_OFFSET (BPLBACCESS_IPIF_DMA_SG_SPACE_OFFSET + 0x00000014)
#define BPLBACCESS_DMA0_BDA_OFFSET (BPLBACCESS_IPIF_DMA_SG_SPACE_OFFSET + 0x00000018)
#define BPLBACCESS_DMA0_SWCR_OFFSET (BPLBACCESS_IPIF_DMA_SG_SPACE_OFFSET + 0x0000001C)
#define BPLBACCESS_DMA0_UPC_OFFSET (BPLBACCESS_IPIF_DMA_SG_SPACE_OFFSET + 0x00000020)
#define BPLBACCESS_DMA0_PCT_OFFSET (BPLBACCESS_IPIF_DMA_SG_SPACE_OFFSET + 0x00000024)
#define BPLBACCESS_DMA0_PWB_OFFSET (BPLBACCESS_IPIF_DMA_SG_SPACE_OFFSET + 0x00000028)
#define BPLBACCESS_DMA0_ISR_OFFSET (BPLBACCESS_IPIF_DMA_SG_SPACE_OFFSET + 0x0000002C)
#define BPLBACCESS_DMA0_IER_OFFSET (BPLBACCESS_IPIF_DMA_SG_SPACE_OFFSET + 0x00000030)
#define BPLBACCESS_DMA1_RST_OFFSET (BPLBACCESS_IPIF_DMA_SG_SPACE_OFFSET + 0x00000040)
#define BPLBACCESS_DMA1_MIR_OFFSET (BPLBACCESS_IPIF_DMA_SG_SPACE_OFFSET + 0x00000040)
#define BPLBACCESS_DMA1_DMACR_OFFSET (BPLBACCESS_IPIF_DMA_SG_SPACE_OFFSET + 0x00000044)
#define BPLBACCESS_DMA1_SA_OFFSET (BPLBACCESS_IPIF_DMA_SG_SPACE_OFFSET + 0x00000048)
#define BPLBACCESS_DMA1_DA_OFFSET (BPLBACCESS_IPIF_DMA_SG_SPACE_OFFSET + 0x0000004C)
#define BPLBACCESS_DMA1_LENGTH_OFFSET (BPLBACCESS_IPIF_DMA_SG_SPACE_OFFSET + 0x00000050)
#define BPLBACCESS_DMA1_DMASR_OFFSET (BPLBACCESS_IPIF_DMA_SG_SPACE_OFFSET + 0x00000054)
#define BPLBACCESS_DMA1_BDA_OFFSET (BPLBACCESS_IPIF_DMA_SG_SPACE_OFFSET + 0x00000058)
#define BPLBACCESS_DMA1_SWCR_OFFSET (BPLBACCESS_IPIF_DMA_SG_SPACE_OFFSET + 0x0000005C)
#define BPLBACCESS_DMA1_UPC_OFFSET (BPLBACCESS_IPIF_DMA_SG_SPACE_OFFSET + 0x00000060)
#define BPLBACCESS_DMA1_PCT_OFFSET (BPLBACCESS_IPIF_DMA_SG_SPACE_OFFSET + 0x00000064)
#define BPLBACCESS_DMA1_PWB_OFFSET (BPLBACCESS_IPIF_DMA_SG_SPACE_OFFSET + 0x00000068)
#define BPLBACCESS_DMA1_ISR_OFFSET (BPLBACCESS_IPIF_DMA_SG_SPACE_OFFSET + 0x0000006C)
#define BPLBACCESS_DMA1_IER_OFFSET (BPLBACCESS_IPIF_DMA_SG_SPACE_OFFSET + 0x00000070)

/**
 * IPIF DMA & Scatter Gather Masks
 * -- DMA_SINC_MASK   : dma source address increment
 * -- DMA_DINC_MASK   : dma destination address increment
 * -- DMA_SLOCAL_MASK : dma source address is local
 * -- DMA_DLOCAL_MASK : dma destination address is local
 * -- DMA_SGS_MASK    : dma scatter gather stop as soon as stop condition occurs
 * -- DMA_L_MASK      : dma last (indicate the last of a data packet during scatter gather operation)
 * -- DMA_MODE_MASK   : dma mode (operation mode of individual dma burst transactions)
 * -- DMA_BSY_MASK    : dma busy
 * -- DMA_DBE_MASK    : dma bus error
 * -- DMA_SGL_MASK    : scatter gather last
 * -- DMA_SGE_MASK    : scatter gather enabled by software control
 * -- DMA_SGBSY_MASK  : scatter gather busy
 * -- DMA_SGEND_MASK  : scatter gather end
 * -- DMA_SGDA_MASK   : scatter gather disable acknowledge
 * -- DMA_PWBR_MASK   : scatter gather packet wait bound reached
 * -- DMA_PCTR_MASK   : scatter gather packet count threshold reached
 * -- DMA_PD_MASK     : scatter gather packet done
 * -- DMA_DE_MASK     : dma error
 * -- DMA_DD_MASK     : dma done
 */
#define DMA_SINC_MASK (0x80000000UL)
#define DMA_DINC_MASK (0x40000000UL)
#define DMA_SLOCAL_MASK (0x20000000UL)
#define DMA_DLOCAL_MASK (0x10000000UL)
#define DMA_SGS_MASK (0x08000000UL)
#define DMA_L_MASK (0x02000000UL)
#define DMA_MODE_MASK (0x01000000UL)
#define DMA_BSY_MASK (0x80000000UL)
#define DMA_DBE_MASK (0x40000000UL)
#define DMA_DBT_MASK (0x20000000UL)
#define DMA_SGL_MASK (0x10000000UL)
#define DMA_SGE_MASK (0x80000000UL)
#define DMA_SGBSY_MASK (0x08000000UL)
#define DMA_SGEND_MASK (0x00000040UL)
#define DMA_SGDA_MASK (0x00000020UL)
#define DMA_PWBR_MASK (0x00000010UL)
#define DMA_PCTR_MASK (0x00000008UL)
#define DMA_PD_MASK (0x00000004UL)
#define DMA_DE_MASK (0x00000002UL)
#define DMA_DD_MASK (0x00000001UL)

/**
 * IPIF Read Packet FIFO Register/Data Space Offsets
 * -- RDFIFO_RST   : read packet fifo reset register
 * -- RDFIFO_MIR   : read packet fifo module identification register
 * -- RDFIFO_SR    : read packet fifo status register
 * -- RDFIFO_DATA  : read packet fifo data
 */
#define BPLBACCESS_IPIF_RDFIFO_REG_SPACE_OFFSET (0x00000500)
#define BPLBACCESS_RDFIFO_RST_OFFSET (BPLBACCESS_IPIF_RDFIFO_REG_SPACE_OFFSET + 0x00000000)
#define BPLBACCESS_RDFIFO_MIR_OFFSET (BPLBACCESS_IPIF_RDFIFO_REG_SPACE_OFFSET + 0x00000000)
#define BPLBACCESS_RDFIFO_SR_OFFSET (BPLBACCESS_IPIF_RDFIFO_REG_SPACE_OFFSET + 0x00000004)
#define BPLBACCESS_IPIF_RDFIFO_DATA_SPACE_OFFSET (0x00000600)
#define BPLBACCESS_RDFIFO_DATA_OFFSET (BPLBACCESS_IPIF_RDFIFO_DATA_SPACE_OFFSET + 0x00000000)

/**
 * IPIF Read Packet FIFO Masks
 * -- RDFIFO_EMPTY_MASK : read packet fifo empty condition
 * -- RDFIFO_AE_MASK    : read packet fifo almost empty condition
 * -- RDFIFO_DL_MASK    : read packet fifo deadlock condition
 * -- RDFIFO_SCL_MASK   : read packet fifo occupancy scaling enabled
 * -- RDFIFO_WIDTH_MASK : read packet fifo encoded data port width
 * -- RDFIFO_OCC_MASK   : read packet fifo occupancy
 */
#define RDFIFO_EMPTY_MASK (0x80000000UL)
#define RDFIFO_AE_MASK (0x40000000UL)
#define RDFIFO_DL_MASK (0x20000000UL)
#define RDFIFO_SCL_MASK (0x10000000UL)
#define RDFIFO_WIDTH_MASK (0x0E000000UL)
#define RDFIFO_OCC_MASK (0x01FFFFFFUL)

/**
 * IPIF Write Packet FIFO Register/Data Space Offsets
 * -- WRFIFO_RST   : write packet fifo reset register
 * -- WRFIFO_MIR   : write packet fifo module identification register
 * -- WRFIFO_SR    : write packet fifo status register
 * -- WRFIFO_DATA  : write packet fifo data
 */
#define BPLBACCESS_IPIF_WRFIFO_REG_SPACE_OFFSET (0x00000700)
#define BPLBACCESS_WRFIFO_RST_OFFSET (BPLBACCESS_IPIF_WRFIFO_REG_SPACE_OFFSET + 0x00000000)
#define BPLBACCESS_WRFIFO_MIR_OFFSET (BPLBACCESS_IPIF_WRFIFO_REG_SPACE_OFFSET + 0x00000000)
#define BPLBACCESS_WRFIFO_SR_OFFSET (BPLBACCESS_IPIF_WRFIFO_REG_SPACE_OFFSET + 0x00000004)
#define BPLBACCESS_IPIF_WRFIFO_DATA_SPACE_OFFSET (0x00000800)
#define BPLBACCESS_WRFIFO_DATA_OFFSET (BPLBACCESS_IPIF_WRFIFO_DATA_SPACE_OFFSET + 0x00000000)

/**
 * IPIF Write Packet FIFO Masks
 * -- WRFIFO_FULL_MASK  : write packet fifo full condition
 * -- WRFIFO_AF_MASK    : write packet fifo almost full condition
 * -- WRFIFO_DL_MASK    : write packet fifo deadlock condition
 * -- WRFIFO_SCL_MASK   : write packet fifo vacancy scaling enabled
 * -- WRFIFO_WIDTH_MASK : write packet fifo encoded data port width
 * -- WRFIFO_DREP_MASK  : write packet fifo DRE present
 * -- WRFIFO_VAC_MASK   : write packet fifo vacancy
 */
#define WRFIFO_FULL_MASK (0x80000000UL)
#define WRFIFO_AF_MASK (0x40000000UL)
#define WRFIFO_DL_MASK (0x20000000UL)
#define WRFIFO_SCL_MASK (0x10000000UL)
#define WRFIFO_WIDTH_MASK (0x0E000000UL)
#define WRFIFO_DREP_MASK (0x01000000UL)
#define WRFIFO_VAC_MASK (0x00FFFFFFUL)

/**************************** Type Definitions *****************************/


/***************** Macros (Inline Functions) Definitions *******************/

/**
 *
 * Write a value to a BPLBACCESS register. A 32 bit write is performed.
 * If the component is implemented in a smaller width, only the least
 * significant data is written.
 *
 * @param   BaseAddress is the base address of the BPLBACCESS device.
 * @param   RegOffset is the register offset from the base to write to.
 * @param   Data is the data written to the register.
 *
 * @return  None.
 *
 * @note
 * C-style signature:
 * 	void BPLBACCESS_mWriteReg(Xuint32 BaseAddress, unsigned RegOffset, Xuint32 Data)
 *
 */
#define BPLBACCESS_mWriteReg(BaseAddress, RegOffset, Data) \
 	XIo_Out32((BaseAddress) + (RegOffset), (Xuint32)(Data))

/**
 *
 * Read a value from a BPLBACCESS register. A 32 bit read is performed.
 * If the component is implemented in a smaller width, only the least
 * significant data is read from the register. The most significant data
 * will be read as 0.
 *
 * @param   BaseAddress is the base address of the BPLBACCESS device.
 * @param   RegOffset is the register offset from the base to write to.
 *
 * @return  Data is the data from the register.
 *
 * @note
 * C-style signature:
 * 	Xuint32 BPLBACCESS_mReadReg(Xuint32 BaseAddress, unsigned RegOffset)
 *
 */
#define BPLBACCESS_mReadReg(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (RegOffset))


/**
 *
 * Check status of BPLBACCESS user logic master module.
 *
 * @param   BaseAddress is the base address of the BPLBACCESS device.
 *
 * @return  Status is the result of status checking.
 *
 * @note
 * C-style signature:
 * 	bool BPLBACCESS_mMasterDone(Xuint32 BaseAddress)
 * 	bool BPLBACCESS_mMasterBusy(Xuint32 BaseAddress)
 *
 */
#define BPLBACCESS_mMasterDone(BaseAddress) \
 	((((Xuint32) XIo_In8((BaseAddress)+(BPLBACCESS_MASTER_SR_OFFSET)))<<16 & MST_DONE_MASK) == MST_DONE_MASK)
#define BPLBACCESS_mMasterBusy(BaseAddress) \
 	((((Xuint32) XIo_In8((BaseAddress)+(BPLBACCESS_MASTER_SR_OFFSET)))<<16 & MST_BSY_MASK) == MST_BSY_MASK)

/**
 *
 * Reset BPLBACCESS via software.
 *
 * @param   BaseAddress is the base address of the BPLBACCESS device.
 *
 * @return  None.
 *
 * @note
 * C-style signature:
 * 	void BPLBACCESS_mReset(Xuint32 BaseAddress)
 *
 */
#define BPLBACCESS_mReset(BaseAddress) \
 	XIo_Out32((BaseAddress)+(BPLBACCESS_RST_OFFSET), IPIF_RESET)

/**
 *
 * Read module identification information from BPLBACCESS device.
 *
 * @param   BaseAddress is the base address of the BPLBACCESS device.
 *
 * @return  None.
 *
 * @note
 * C-style signature:
 * 	Xuint32 BPLBACCESS_mReadMIR(Xuint32 BaseAddress)
 *
 */
#define BPLBACCESS_mReadMIR(BaseAddress) \
 	XIo_In32((BaseAddress)+(BPLBACCESS_MIR_OFFSET))

/**
 *
 * Reset DMA channel of BPLBACCESS to initial state.
 *
 * @param   BaseAddress is the base address of the BPLBACCESS device.
 *
 * @return  None.
 *
 * @note
 * C-style signature:
 * 	void BPLBACCESS_mResetDMA0(Xuint32 BaseAddress)
 * 	void BPLBACCESS_mResetDMA1(Xuint32 BaseAddress)
 *
 */
#define BPLBACCESS_mResetDMA0(BaseAddress) \
 	XIo_Out32((BaseAddress)+(BPLBACCESS_DMA0_RST_OFFSET), IPIF_RESET)
#define BPLBACCESS_mResetDMA1(BaseAddress) \
 	XIo_Out32((BaseAddress)+(BPLBACCESS_DMA1_RST_OFFSET), IPIF_RESET)

/**
 *
 * Set/Get DMA control register of BPLBACCESS DMA channel.
 *
 * @param   BaseAddress is the base address of the BPLBACCESS device.
 * @param   Mask is the control bit(s) to be set.
 *
 * @return  None.
 *
 * @note
 * C-style signature:
 * 	void BPLBACCESS_mSetDMA0Control(Xuint32 BaseAddress, Xuint32 Mask)
 * 	void BPLBACCESS_mSetDMA1Control(Xuint32 BaseAddress, Xuint32 Mask)
 * 	Xuint32 BPLBACCESS_mGetDMA0Control(Xuint32 BaseAddress)
 * 	Xuint32 BPLBACCESS_mGetDMA1Control(Xuint32 BaseAddress)
 *
 */
#define BPLBACCESS_mSetDMA0Control(BaseAddress, Mask) \
 	XIo_Out32((BaseAddress)+(BPLBACCESS_DMA0_DMACR_OFFSET), (Xuint32)(Mask))
#define BPLBACCESS_mSetDMA1Control(BaseAddress, Mask) \
 	XIo_Out32((BaseAddress)+(BPLBACCESS_DMA1_DMACR_OFFSET), (Xuint32)(Mask))
#define BPLBACCESS_mGetDMA0Control(BaseAddress) \
 	XIo_In32((BaseAddress)+(BPLBACCESS_DMA0_DMACR_OFFSET))
#define BPLBACCESS_mGetDMA1Control(BaseAddress) \
 	XIo_In32((BaseAddress)+(BPLBACCESS_DMA1_DMACR_OFFSET))

/**
 *
 * Get DMA status register of BPLBACCESS DMA channel.
 *
 * @param   BaseAddress is the base address of the BPLBACCESS device.
 *
 * @return  Status is the DMA channel status.
 *
 * @note
 * C-style signature:
 * 	Xuint32 BPLBACCESS_mGetDMA0Status(Xuint32 BaseAddress)
 * 	Xuint32 BPLBACCESS_mGetDMA1Status(Xuint32 BaseAddress)
 * 	bool BPLBACCESS_mDMA0Error(Xuint32 BaseAddress)
 * 	bool BPLBACCESS_mDMA1Error(Xuint32 BaseAddress)
 * 	bool BPLBACCESS_mDMA0Done(Xuint32 BaseAddress)
 * 	bool BPLBACCESS_mDMA1Done(Xuint32 BaseAddress)
 *
 */
#define BPLBACCESS_mGetDMA0Status(BaseAddress) \
 	XIo_In32((BaseAddress)+(BPLBACCESS_DMA0_DMASR_OFFSET))
#define BPLBACCESS_mGetDMA1Status(BaseAddress) \
 	XIo_In32((BaseAddress)+(BPLBACCESS_DMA1_DMASR_OFFSET))
#define BPLBACCESS_mDMA0Error(BaseAddress) \
 	((XIo_In32((BaseAddress)+(BPLBACCESS_DMA0_ISR_OFFSET)) & DMA_DE_MASK) == DMA_DE_MASK)
#define BPLBACCESS_mDMA1Error(BaseAddress) \
 	((XIo_In32((BaseAddress)+(BPLBACCESS_DMA1_ISR_OFFSET)) & DMA_DE_MASK) == DMA_DE_MASK)
#define BPLBACCESS_mDMA0Done(BaseAddress) \
 	((XIo_In32((BaseAddress)+(BPLBACCESS_DMA0_ISR_OFFSET)) & DMA_DD_MASK) == DMA_DD_MASK)
#define BPLBACCESS_mDMA1Done(BaseAddress) \
 	((XIo_In32((BaseAddress)+(BPLBACCESS_DMA1_ISR_OFFSET)) & DMA_DD_MASK) == DMA_DD_MASK)

/**
 *
 * Reset read packet FIFO of BPLBACCESS to its initial state.
 *
 * @param   BaseAddress is the base address of the BPLBACCESS device.
 *
 * @return  None.
 *
 * @note
 * C-style signature:
 * 	void BPLBACCESS_mResetReadFIFO(Xuint32 BaseAddress)
 *
 */
#define BPLBACCESS_mResetReadFIFO(BaseAddress) \
 	XIo_Out32((BaseAddress)+(BPLBACCESS_RDFIFO_RST_OFFSET), IPIF_RESET)

/**
 *
 * Check status of BPLBACCESS read packet FIFO module.
 *
 * @param   BaseAddress is the base address of the BPLBACCESS device.
 *
 * @return  Status is the result of status checking.
 *
 * @note
 * C-style signature:
 * 	bool BPLBACCESS_mReadFIFOEmpty(Xuint32 BaseAddress)
 * 	Xuint32 BPLBACCESS_mReadFIFOOccupancy(Xuint32 BaseAddress)
 *
 */
#define BPLBACCESS_mReadFIFOEmpty(BaseAddress) \
 	((XIo_In32((BaseAddress)+(BPLBACCESS_RDFIFO_SR_OFFSET)) & RDFIFO_EMPTY_MASK) == RDFIFO_EMPTY_MASK)
#define BPLBACCESS_mReadFIFOOccupancy(BaseAddress) \
 	(XIo_In32((BaseAddress)+(BPLBACCESS_RDFIFO_SR_OFFSET)) & RDFIFO_OCC_MASK)

/**
 *
 * Reset write packet FIFO of BPLBACCESS to its initial state.
 *
 * @param   BaseAddress is the base address of the BPLBACCESS device.
 *
 * @return  None.
 *
 * @note
 * C-style signature:
 * 	void BPLBACCESS_mResetWriteFIFO(Xuint32 BaseAddress)
 *
 */
#define BPLBACCESS_mResetWriteFIFO(BaseAddress) \
 	XIo_Out32((BaseAddress)+(BPLBACCESS_WRFIFO_RST_OFFSET), IPIF_RESET)

/**
 *
 * Check status of BPLBACCESS write packet FIFO module.
 *
 * @param   BaseAddress is the base address of the BPLBACCESS device.
 *
 * @return  Status is the result of status checking.
 *
 * @note
 * C-style signature:
 * 	bool BPLBACCESS_mWriteFIFOFull(Xuint32 BaseAddress)
 * 	Xuint32 BPLBACCESS_mWriteFIFOVacancy(Xuint32 BaseAddress)
 *
 */
#define BPLBACCESS_mWriteFIFOFull(BaseAddress) \
 	((XIo_In32((BaseAddress)+(BPLBACCESS_WRFIFO_SR_OFFSET)) & WRFIFO_FULL_MASK) == WRFIFO_FULL_MASK)
#define BPLBACCESS_mWriteFIFOVacancy(BaseAddress) \
 	(XIo_In32((BaseAddress)+(BPLBACCESS_WRFIFO_SR_OFFSET)) & WRFIFO_VAC_MASK)

/************************** Function Prototypes ****************************/


/**
 *
 * Write/Read value to/from BPLBACCESS user logic slave registers.
 *
 * @param   baseaddr_p is the base address of the BPLBACCESS device.
 * @param   data is a point to a given Xuint64 structure for fetching or storing value.
 *
 * @return  None.
 *
 * @note    data should be allocated by the caller.
 *
 */
void BPLBACCESS_WriteSlaveReg0(void * baseaddr_p, Xuint64 * data);
void BPLBACCESS_WriteSlaveReg1(void * baseaddr_p, Xuint64 * data);
void BPLBACCESS_WriteSlaveReg2(void * baseaddr_p, Xuint64 * data);
void BPLBACCESS_WriteSlaveReg3(void * baseaddr_p, Xuint64 * data);
void BPLBACCESS_WriteSlaveReg4(void * baseaddr_p, Xuint64 * data);
void BPLBACCESS_WriteSlaveReg5(void * baseaddr_p, Xuint64 * data);
void BPLBACCESS_WriteSlaveReg6(void * baseaddr_p, Xuint64 * data);
void BPLBACCESS_WriteSlaveReg7(void * baseaddr_p, Xuint64 * data);
void BPLBACCESS_WriteSlaveReg8(void * baseaddr_p, Xuint64 * data);
void BPLBACCESS_WriteSlaveReg9(void * baseaddr_p, Xuint64 * data);
void BPLBACCESS_WriteSlaveReg10(void * baseaddr_p, Xuint64 * data);
void BPLBACCESS_WriteSlaveReg11(void * baseaddr_p, Xuint64 * data);
void BPLBACCESS_WriteSlaveReg12(void * baseaddr_p, Xuint64 * data);
void BPLBACCESS_WriteSlaveReg13(void * baseaddr_p, Xuint64 * data);
void BPLBACCESS_WriteSlaveReg14(void * baseaddr_p, Xuint64 * data);
void BPLBACCESS_WriteSlaveReg15(void * baseaddr_p, Xuint64 * data);

void BPLBACCESS_ReadSlaveReg0(void * baseaddr_p, Xuint64 * data);
void BPLBACCESS_ReadSlaveReg1(void * baseaddr_p, Xuint64 * data);
void BPLBACCESS_ReadSlaveReg2(void * baseaddr_p, Xuint64 * data);
void BPLBACCESS_ReadSlaveReg3(void * baseaddr_p, Xuint64 * data);
void BPLBACCESS_ReadSlaveReg4(void * baseaddr_p, Xuint64 * data);
void BPLBACCESS_ReadSlaveReg5(void * baseaddr_p, Xuint64 * data);
void BPLBACCESS_ReadSlaveReg6(void * baseaddr_p, Xuint64 * data);
void BPLBACCESS_ReadSlaveReg7(void * baseaddr_p, Xuint64 * data);
void BPLBACCESS_ReadSlaveReg8(void * baseaddr_p, Xuint64 * data);
void BPLBACCESS_ReadSlaveReg9(void * baseaddr_p, Xuint64 * data);
void BPLBACCESS_ReadSlaveReg10(void * baseaddr_p, Xuint64 * data);
void BPLBACCESS_ReadSlaveReg11(void * baseaddr_p, Xuint64 * data);
void BPLBACCESS_ReadSlaveReg12(void * baseaddr_p, Xuint64 * data);
void BPLBACCESS_ReadSlaveReg13(void * baseaddr_p, Xuint64 * data);
void BPLBACCESS_ReadSlaveReg14(void * baseaddr_p, Xuint64 * data);
void BPLBACCESS_ReadSlaveReg15(void * baseaddr_p, Xuint64 * data);

/**
 *
 * DMA transfer between source address and destination address, either the source or the destination address.
 * must be local to the BPLBACCESS device.
 *
 * @param   BaseAddress is the base address of the BPLBACCESS device.
 * @param   SrcAddress is the source address from which the data will be fetched.
 * @param   DstAddress is the destination address to which the data will be stored.
 * @param   ByteCount is the number of bytes to be sent.
 *
 * @return  None.
 *
 * @note    None.
 *
 */
void BPLBACCESS_DMA0Transfer(Xuint32 BaseAddress, Xuint32 SrcAddress, Xuint32 DstAddress, Xuint32 ByteCount);
void BPLBACCESS_DMA1Transfer(Xuint32 BaseAddress, Xuint32 SrcAddress, Xuint32 DstAddress, Xuint32 ByteCount);
/**
 *
 * Read data from BPLBACCESS read packet FIFO module.
 *
 * @param   baseaddr_p is the base address of the BPLBACCESS device.
 * @param   data is a point to a given Xuint64 structure for fetching or storing value.
 *
 * @return  None.
 *
 * @note    data should be allocated by the caller.
 *
 */
void BPLBACCESS_ReadFromFIFO(void * baseaddr_p, Xuint64 * data);
/**
 *
 * Write data to BPLBACCESS write packet FIFO module.
 *
 * @param   baseaddr_p is the base address of the BPLBACCESS device.
 * @param   data is a point to a given Xuint64 structure for fetching or storing value.
 *
 * @return  None.
 *
 * @note    data should be allocated by the caller.
 *
 */
void BPLBACCESS_WriteToFIFO(void * baseaddr_p, Xuint64 * data);

/**
 *
 * Enable all possible interrupts from BPLBACCESS device.
 *
 * @param   baseaddr_p is the base address of the BPLBACCESS device.
 *
 * @return  None.
 *
 * @note    None.
 *
 */
void BPLBACCESS_EnableInterrupt(void * baseaddr_p);

/**
 *
 * Example interrupt controller handler.
 *
 * @param   baseaddr_p is the base address of the BPLBACCESS device.
 *
 * @return  None.
 *
 * @note    None.
 *
 */
void BPLBACCESS_Intr_DefaultHandler(void * baseaddr_p);

/**
 *
 * Run a self-test on the driver/device. Note this may be a destructive test if
 * resets of the device are performed.
 *
 * If the hardware system is not built correctly, this function may never
 * return to the caller.
 *
 * @param   baseaddr_p is the base address of the BPLBACCESS instance to be worked on.
 *
 * @return
 *
 *    - XST_SUCCESS   if all self-test code passed
 *    - XST_FAILURE   if any self-test code failed
 *
 * @note    Caching must be turned off for this function to work.
 * @note    Self test may fail if data memory and device are not on the same bus.
 *
 */
XStatus BPLBACCESS_SelfTest(void * baseaddr_p);

#endif // BPLBACCESS_H
